unit FilterDialog;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, Spin, EditBtn, Buttons;

type

  { TFormFilterdialog }

  TFormFilterdialog = class(TForm)
    ButtonCancel: TButton;
    ButtonOK: TButton;
    CheckBoxSave: TCheckBox;
    CheckBoxNil: TCheckBox;
    CheckBoxLevel: TCheckBox;
    EditSuffix: TEdit;
    FileNameEditFilter: TFileNameEdit;
    FloatSpinEditAmp: TFloatSpinEdit;
    FloatSpinEditH1: TFloatSpinEdit;
    FloatSpinEditH2: TFloatSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    PaintBox1: TPaintBox;
    RadioGroup1: TRadioGroup;
    procedure CheckBoxLevelChange(Sender: TObject);
    procedure CheckBoxSaveChange(Sender: TObject);
    procedure CheckBoxNilChange(Sender: TObject);
    procedure EditSuffixChange(Sender: TObject);
    procedure FloatSpinEditAmpChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure PaintBars;
    procedure RadioGroup1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  FormFilterdialog: TFormFilterdialog;

implementation uses main;

{ TFormFilterdialog }

procedure TFormFilterdialog.FormCreate(Sender: TObject);
          begin
          with Mainform do
          FileNameEditFilter.FileName:=newName(FileNameOpenEditor.filename,'_filter'+EditSuffix.Text,'dat');
          end;

procedure TFormFilterdialog.FloatSpinEditAmpChange(Sender: TObject);
          begin
          Label3.Caption:='оставить ('+inttostr(round((check.MinAmplitude-FloatSpinEditAmp.Value)/check.MinAmplitude*100))+'%)';
          end;

procedure TFormFilterdialog.EditSuffixChange(Sender: TObject);
          begin
          with Mainform do
          FileNameEditFilter.FileName:=newName(FileNameOpenEditor.filename,'_filter'+EditSuffix.Text,'dat');
          end;

procedure TFormFilterdialog.CheckBoxNilChange(Sender: TObject);
          begin
          FloatSpinEditH1.Enabled:=not CheckBoxNil.Checked;
          FloatSpinEditH2.Enabled:=not CheckBoxNil.Checked;
          if not CheckBoxNil.Checked then
          begin
          FloatSpinEditAmp.Enabled:=CheckBoxLevel.Checked;
          Label3.Enabled:=CheckBoxLevel.Checked;
          end
          else
          begin
          FloatSpinEditAmp.Enabled:=false;
          Label3.Enabled:=false;
          end;
          RadioGroup1.Enabled:=not CheckBoxNil.Checked;
          CheckBoxLevel.Enabled:=not CheckBoxNil.Checked;
          Label1.Enabled:=not CheckBoxNil.Checked;
          Label2.Enabled:=not CheckBoxNil.Checked;

          Label6.Enabled:=not CheckBoxNil.Checked;
          Label7.Enabled:=not CheckBoxNil.Checked;
          PaintBox1.Enabled:=not CheckBoxNil.Checked;
          end;

procedure TFormFilterdialog.CheckBoxSaveChange(Sender: TObject);
          begin
          FileNameEditFilter.Enabled:=CheckBoxSave.Checked;
          Label5.Enabled:=CheckBoxSave.Checked;
          EditSuffix.Enabled:=CheckBoxSave.Checked;
          end;

procedure TFormFilterdialog.CheckBoxLevelChange(Sender: TObject);
          begin
          FloatSpinEditAmp.Enabled:=CheckBoxLevel.Checked;
          //if not CheckBoxNil.Checked then
          Label3.Enabled:=CheckBoxLevel.Checked;
          end;




procedure TFormFilterdialog.FormPaint(Sender: TObject);
          begin
          PaintBars;
          end;



procedure TFormFilterdialog.PaintBars;
          var x1,x2,y1,y2,y3,y4:integer;
          Begin
          with PaintBox1.Canvas do
          begin
          pen.style:=pssolid;
          brush.style:=bssolid;
          x1:=0;
          x2:=PaintBox1.Width;
          y1:=0;
          y2:=30;
          y3:=62;
          y4:=PaintBox1.Height;
          Brush.Color:=clCream;
          Pen.Color:=clDkGray;
          Rectangle(x1,y1,x2,y4);

          Brush.Color:=clDkGray;
          Pen.Color:=clDkGray;
          case RadioGroup1.ItemIndex of
          0:Rectangle(x1,y1,x2,y2);
          1:Rectangle(x1,y2,x2,y3);
          2:Rectangle(x1,y3,x2,y4);
          end;
          end;

          End;

procedure TFormFilterdialog.RadioGroup1Click(Sender: TObject);
          begin
          PaintBars;
          case RadioGroup1.ItemIndex of
          0:begin label1.Visible:=true;FloatSpinEditH1.visible:=true;FloatSpinEditH2.visible:=false;label2.Visible:=false;end;
          1:begin FloatSpinEditH1.visible:=true;label1.Visible:=true;FloatSpinEditH2.visible:=true;label2.Visible:=true;end;
          2:begin FloatSpinEditH1.visible:=false;label1.Visible:=false;FloatSpinEditH2.visible:=true;label2.Visible:=true;end;
          end;

          end;


initialization
  {$I filterdialog.lrs}

end.





