unit loadcoe;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,  Dialogs;

 type
 TCharSet = set of Char;

 var   coe:array[1..5000,1..2] of double;
       dat:array[1..5000,1..5] of double;
       datxmin:double;
       datxmax:double;
       datymin:double;
       datymax:double;
       lheader:word;
       len:longint;
       ndat:longint;
       col_x:word;
       col_y:word;

 procedure LoadParameters(s:string);
 function  LoadCoedat(s:string):boolean;
 function  GetIndex(nmax:longint;x:double):longint;
 function  foss(nmax:longint;x:double):double;
 procedure TabDat;

 {WordCount возвращает кол-во слов разделенных символами-разделителями из WordDelims}
 function WordCount(S: string; const WordDelims: Tcharset): integer;
 {WordPosition возвращает начальную позицию N-го слова из строки S с разделителями из WordDelims}
 function WordPosition(N: integer; S: string; const WordDelims: TCharset): integer;
 {ExtractWord возвращает N-е слово из строки S с разделителями из WordDelims}
 function ExtractWord(N: integer; S: string; const WordDelims: TCharSet): string;

implementation

function WordCount(S: string; const WordDelims: TCharSet): integer;
var
  SLen, I: Cardinal;
begin
  Result := 0;
  I := 1;
  SLen := Length(S);
  while I <= SLen do begin
    while (I <= SLen) and (S[I] in WordDelims) do Inc(I);
    if I <= SLen then Inc(Result);
    while (I <= SLen) and not(S[I] in WordDelims) do Inc(I);
  end;
end;

function WordPosition(N: integer; S: string; const WordDelims: TCharSet): integer;
var Count, i: integer;
begin
  Count := 0;
  i := 1;
  Result := 0;
  while (i <= Length(S)) and (Count <> N) do begin
    { skip over delimiters }
    while (i <= Length(S)) and (S[i] in WordDelims) do inc(i);
    { if we're not beyond end of S, we're at the start of a word }
    if i <= Length(S) then inc(Count);
    { if not finished, find the end of the current word }
    if Count <> N
      then while (i <= Length(S)) and not (S[i] in WordDelims) do inc(i)
      else Result := i;
  end;
end;

function ExtractWord(N: integer; S: string; const WordDelims: TCharSet): string;
var i: integer;
    Len: integer;
begin
  Len := 0;
  i := WordPosition(N, S, WordDelims);
  if i <> 0 then
    { find the end of the current word }
    while (i <= Length(S)) and not(S[i] in WordDelims) do begin
      { add the I'th character to result }
      inc(Len);
      SetLength(Result, Len);
      Result[Len] := S[i];
      inc(i);
    end;
  SetLength(Result, Len);
end;
    procedure   LoadParameters(s:string);
                var f:textfile;
                Begin
                if (not FileExists(s)) then ShowMessage('ini-файл '+s+' не найден');
                assignfile(f,s);
                reset(f);
                readln(f,lheader);
                readln(f,ndat);
                readln(f,col_x);
                readln(f,col_y);
                readln(f);
                readln(f);
                closefile(f);
                End;
                
                
     function   LoadCoeDat(s:string):boolean;
                var f:textfile;
                    i,k:integer;
                    c,x:double;
                    si:string;
                Begin
                assignfile(f,s);
                {$I-}
                reset(f);
                {$I+}
                if IOResult<>0
                then
                begin
                showmessage('файл '+s+' не найден');
                LoadCoeDat:=false;
                exit;
                end;

                if lheader=0 then
                begin
                reset(f);
                readln(f,si);
                while not TryStrToFloat(ExtractWord(1,si,[',',' ',#9,';']),x) do
                begin
                lheader:=lheader+1;
                readln(f,si);
                end;
                end;
                closefile(f);

                reset(f);
                for i:=1 to lheader do readln(f);
                len:=0;
                repeat
                len:=len+1;
                for k:=1 to col_x-1 do read(f,c);
                readln(f,coe[len,1]);
                until seekeoln(f);
                closefile(f);

                reset(f);
                for k:=1 to lheader do readln(f);
                for i:=1 to len do
                begin
                for k:=1 to col_y-1 do read(f,c);
                readln(f,coe[i,2]);
                end;
                closefile(f);

                datxmin:=+1e10;
                datxmax:=-1e10;
                datymin:=+1e10;
                datymax:=-1e10;
                for i:=1 to len do
                begin
                if coe[i,1]>datxmax then datxmax:=coe[i,1];
                if coe[i,1]<datxmin then datxmin:=coe[i,1];
                if coe[i,2]>datymax then datymax:=coe[i,2];
                if coe[i,2]<datymin then datymin:=coe[i,2];
                end;
                if ndat=0 then ndat:=len;
                LoadCoeDat:=true;
                End;

      function  GetIndex(nmax:longint;x:double):longint;
                var i,i1,i2,k,n1,n2,kmax:longint;
                Begin
                kmax:=trunc(ln(nmax)/ln(2));
                n1:=1;
                n2:=nmax;
                for k:=1 to kmax do
                begin

                for i:=1 to 2 do
                begin
                i1:=n1+trunc((i-1)*(n2-n1+1)/2);
                i2:=n1+trunc((i-0)*(n2-n1+1)/2)-1;
                if ((x>coe[i1,1]) and (x<coe[i2,1]))
                then
                begin
                n1:=i1;
                n2:=i2;
                break;
                end;{if}

                end;{i}
                end;{k}


                for i:=n1 to nmax do
                begin
                if (x<coe[i,1]) then break;
                end;

                GetIndex:=i-1;
                End;


      function  foss(nmax:longint;x:double):double;
                var k:longint;
                y1,y2:double;
                x1,x2:double;
                xi:double;
                Begin
                xi:=x;
                k:=GetIndex(nmax,x);

                if (k<1)
                then
                begin
                foss:=coe[1,2];
                exit;
                end;

                if (k+1>nmax)
                then
                begin
                foss:=coe[nmax,2];
                exit;
                end;

                y1:=coe[k+0,2];
                y2:=coe[k+1,2];
                x1:=coe[k+0,1];
                x2:=coe[k+1,1];

                foss:=(y2*(xi-x1)-y1*(xi-x2))/(x2-x1);
                End;

      procedure TabDat;
                var x,dx:double;
                    i:integer;
                Begin
                dx:=(datxmax-datxmin)/(ndat-1);
                x:=datxmin;
                for i:=1 to ndat do
                begin
                dat[i,1]:=x;
                dat[i,2]:=foss(len,x);
                x:=x+dx;
                end;
                
                End;
end.

