unit Main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs,
  loadcoe, EditBtn, Buttons, ExtCtrls, ComCtrls,
  mathwave, montage, StdCtrls, Spin, inioptions, FilterDialog, math;

type
  TisoArray = array[1..100] of double;
  Tcell = array [1..4,1..3] of double;
  Tpalette = array [0..255,1..3] of integer;
  
type

  { TMainForm }

  TMainForm = class(TForm)
    Auto: TButton;
    BitBtn1: TBitBtn;
    Buttonexport: TButton;
    ButtonImport: TButton;
    ButtonSmooth: TButton;
    ButtonSources: TButton;
    ButtonStop: TButton;
    ButtonWave: TButton;
    CheckGroupShow: TCheckGroup;
    FileNameImportEditor: TFileNameEdit;
    FileNameOpenEditor: TFileNameEdit;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    LabelCountm: TLabel;
    LabelCountScales: TLabel;
    LabelMNK: TLabel;
    LabelNfiles: TLabel;
    LabelInfo: TLabel;
    Labelnsources: TLabel;
    LabelWMNK: TLabel;
    OpenBotton: TButton;
    OpenDialogAuto: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    PBmap: TPaintBox;
    PBplot: TPaintBox;
    ProgressWave: TProgressBar;
    ProgressBarAuto: TProgressBar;
    RadioGroupGeomethod: TRadioGroup;
    Splitter1: TSplitter;

    procedure BitBtn1Click(Sender: TObject);
    procedure CheckGroupShowClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure LoadAutoMagic;
    procedure AutoClick(Sender: TObject);
    procedure ButtonImportClick(Sender: TObject);
    procedure ButtonSmoothClick(Sender: TObject);
    procedure ButtonStopClick(Sender: TObject);
    procedure CheckGroupShowItemClick(Sender: TObject; Index: integer);
     function newName(sname,ins,ext:string):string;
    procedure ButtonexportClick(Sender: TObject);
    procedure PBmapMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer
      );
    procedure PBmapPaint(Sender: TObject);
    procedure PBplotPaint(Sender: TObject);
    procedure RadioGroupGeomethodClick(Sender: TObject);
    procedure RefreshMap(Sender: TObject);
    procedure ButtonSourcesClick(Sender: TObject);
    procedure ButtonWaveClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure OpenBottonClick(Sender: TObject);
    procedure PlotData(k:integer);
    
    procedure GetRGBColor(sColor: TColor; out R,G,B:Byte);
    function  PutRGBColor(R,G,B:byte):Tcolor;
    procedure Splitter1CanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure Splitter1Moved(Sender: TObject);
    procedure VisualMap(var PB:TPaintBox;var map:TMapArray;nx,ny:longint;var tiso:Tisoarray;niso:longint;tmin,tmax:double);
    procedure VisualPost(var PB:TPaintBox;var sfinish:TfinishArray;nf:longint;sx1,sx2,sy1,sy2:double;cl:Tcolor);
    procedure VisualSources(var PB:TPaintBox;var sfinish:TfinishArray;nf:longint;sx1,sx2,sy1,sy2:double);
    procedure VisualWaveBar(var PB:TPaintBox;sx1,sx2,sy1,sy2:double);
    procedure  TabDat5col;
    
  private
    { private declarations }
    procedure  PutCell(i,k:longint;dx,dy:double;var map:TMapArray;var Cell:Tcell);
    procedure  FillPalette;
     function  Getcellmin(Cell:Tcell):double;
     function  CellPutPolygonIso(var Cell:Tcell;yb:integer;iso:double;var points:array of TPoint;var len:word):boolean;


    
  public
    { public declarations }
  end; 

var
   paletteMap : Tpalette;
  npalettemap : word;
          iso : TIsoArray;
        smiso : TIsoArray;
        
    geomethod : byte;

           hr : double;


     MainForm : TMainForm;
        check : Tmontage;
        
         bdat : boolean;   {загруженность профиля}
      bkarkas : boolean;   {загруженность w-ряда}
         bmap : boolean;   {загруженность W-карты}
        bgrid : boolean;   {загруженность грида}
      bsource : boolean;   {загруженность источников}
      bsmooth : boolean;   {загруженность плотностной карты}
  
     bmapshow : boolean;   {отображение w-карты}
     bwavebar : boolean;
  bsourceshow : boolean;   {отображение источников}
  bsmoothshow : boolean;   {отображение плотностной карты}

  bautosmooth : boolean;   {отображение плотностной карты  в авторежиме}

         bmnk : boolean = false; {выбор типа метрики true - MNK, false - WMNK}

  p1     : longint; {метрика W-невязки}
  p2     : longint; {степень нормировки по глубине в W-невязке}


implementation uses TabGrid, exportdata, Smooth;

{ TMainForm }

 function  TMainForm.newName(sname,ins,ext:string):string;
              var namebuf:string;
                  l,le:byte;
              Begin
              namebuf:=sname;
              l:=pos('.',namebuf);
              le:=length(sname);
              delete(namebuf,l,le-l+1);
              newname:=namebuf+ins+'.'+ext;
              End;

 procedure TMainForm.ButtonImportClick(Sender: TObject);
           var f: textfile;
               i,c:integer;
               sfile:string;
           begin
           sfile:=UTF8Decode(FileNameImportEditor.filename);
           if (sfile='') then exit;

           assignfile(f,sfile);
           reset(f);
           c:=0;
           repeat
           c:=c+1;
           with check do
           readln(f,source[c,1],source[c,2],source[c,3],source[c,4]);
           until seekeoln(f);
           closefile(f);
           
           for i:=1 to c do check.source[i,2]:=abs(check.source[i,2]);
           check.nsources:=c;
           bsource:=true;
           bsourceshow:=true;
           CheckGroupShow.Checked[2]:=true;
           CheckGroupShow.CheckEnabled[2]:=true;
           buttonSmooth.Enabled:=true;
           labelnsources.caption:='sources: '+inttostr(check.nsources);
           //TabDat5col;
           refreshMap(self);
           End;

  procedure TMainForm.LoadAutoMagic;
            var f:textfile;
                x:integer;
                s:string;
            Begin
            with check do
            begin
            if not FileExists('automagic.ini') then
            begin ShowMessage('the file "automagic.ini" not found');exit;end;
            assignfile(f,'automagic.ini');
            reset(f);
            readln(f,geomethod);
            readln(f,wx1);
            readln(f,wx2);
            readln(f,gmx);
            readln(f,wy1);
            readln(f,wy2);
            readln(f,gmy);
            readln(f,nsensor);
            readln(f,ncycles);
            readln(f,maxnsources);

            readln(f,x);if x=1 then checkplus:=true else checkplus:=false;
            readln(f,x);if x=1 then checkminus:=true else checkminus:=false;

            readln(f,smmx);
            readln(f,smmy);
            readln(f,smaspect);
            readln(f,smwidth);
            readln(f,s);
            if s='true' then bautosmooth:=true else bautosmooth:=false;
            closefile(f);
            end;
            End;

  procedure TMainForm.CheckGroupShowClick(Sender: TObject);
            begin

            end;

  procedure TMainForm.BitBtn1Click(Sender: TObject);
            Begin
            with TFormINI.Create(self) do
            begin
            Hide;

            if ShowModal = mrOK then
            Begin
            End;
            Free;
            end;
            End;

  procedure TMainForm.FormResize(Sender: TObject);
            begin

            pbplot.Top:=0;
            pbplot.left:=1;
            pbplot.Width:=Panel3.Width-2;
            pbplot.Height:=round((panel3.Height-Splitter1.Height)*hr/(1+hr));

            Splitter1.Top:=pbplot.Height+1;
            Splitter1.Left:=1;
            Splitter1.Width:=Panel3.Width-2;

            pbmap.Top:=Splitter1.Top+Splitter1.Height+1;
            pbmap.Left:=1;
            pbmap.Width:=Panel3.Width-2;
            pbmap.Height:=round(pbplot.Height/hr);

            hr:=pbplot.Height/pbmap.Height;
            end;


 procedure TMainForm.AutoClick(Sender: TObject);
           var j,i,k,fmx,fmy,c:integer;
               f:textfile;
               dx,x,dy,y,fx1,fx2,fy1,fy2:double;
               sfile:string;
           begin
           if (not OpenDialogAuto.Execute) or (OpenDialogAuto.Files.Count<1) then exit;
           with ProgressBarAuto do
           begin
           Min:=0;
           c:=OpenDialogAuto.Files.Count;
           Max:=Min+c;
           Step:=1;
           ProgressBarAuto.Position:=0;
           end;

           for j:=0 to c-1 do
           with mainform,check do
           begin
           LabelNfiles.Visible:=true;
           LabelNfiles.Caption:='files: '+inttostr(j+1)+' out of '+inttostr(c);
           if check.bstop then break;

           application.ProcessMessages;
           ProgressBarAuto.Position:=j;

           sfile:=OpenDialogAuto.Files.Strings[j];
           FileNameOpenEditor.FileName:=sfile;
           sfile:=UTF8Decode(sfile);
           if (sfile='') or (not FileExists(sfile)) then exit;
           LoadAutoMagic;
           RadioGroupGeomethod.ItemIndex:=geomethod-1;
           LoadParameters('gravimagic.ini');
           LoadCoeDat(sfile);
           TabDat;
           Create;
           Loadset;
           LoadData;
           Create_medium;
           PsiTabulation;
           PutToNewData(ProgressWave);

           LoadAutoMagic;

           bdat:=true;
           bkarkas:=true;

           labelCountm.Caption:='W-coefficients: '+ inttostr(check.m);
           labelCountScales.Caption:='scales: '+ inttostr(check.tower);
           labelnsources.caption:='sources: ';
           LabelWMNK.Caption:='W-residual: ';

           TabGMap(ProgressWave,LabelInfo);
           disp0:=WMNK;

           nsources:=0;
           bsource:=true;
           bsourceshow:=true;

           bsmooth:=false;
           bsmoothshow:=false;
           ButtonStop.Visible:=true;
           bwavebar:=false;
           RefreshMap(Nil);
           SearchAll(ProgressWave,LabelInfo,Labelnsources,LabelWMNK,LabelMNK);
           ButtonStop.Visible:=false;
           CheckGroupShow.Checked[2]:=true;
           CheckGroupShow.CheckEnabled[2]:=true;

 {
          bsource:=true;
          bsourceshow:=true;
          CheckGroupShow.Checked[2]:=true;
          CheckGroupShow.CheckEnabled[2]:=true;

          bwavebar:=true;
          CheckGroupShow.Checked[3]:=true;
          CheckGroupShow.CheckEnabled[3]:=true;

          b1:=bmapshow;
          bmapshow:=false;
          b2:=bsmoothshow;
          bsmoothshow:=false;
          b3:=bwavebar;bwavebar:=false;
          buttonstop.Visible:=true;
          bstop:=false;
          RefreshMap(Nil);
          SearchAll(ProgressWave,LabelInfo,Labelnsources,LabelWMNK,LabelMNK);
          bstop:=false;
          buttonstop.Visible:=false;

 }

           TabsmMap;
           for k:=1 to npalettemap do smiso[k]:=(smmin)+(k-1)*(smmax-smmin)/(npalettemap-1);
           bsmooth:=bautosmooth;
           bsmoothshow:=bautosmooth;
           CheckGroupShow.Checked[1]:=bautosmooth;
           CheckGroupShow.CheckEnabled[1]:=bautosmooth;
           bwavebar:=true;
           CheckGroupShow.Checked[3]:=true;
           CheckGroupShow.CheckEnabled[3]:=true;
           refreshMap(self);


           assignfile(f,newName(UTF8decode(FileNameOpenEditor.filename),'_sources','dat'));
           rewrite(f);
           for k:=1 to nsources do
           writeln(f,source[k,1],' ',-source[k,2],' ',source[k,3],' ',source[k,4]);
           closefile(f);


           assignfile(f,newName(UTF8decode(FileNameOpenEditor.filename),'_plot','dat'));
           rewrite(f);
           for k:=1 to ndat do writeln(f,dat[k,1],' ',dat[k,2],' ',dat[k,5]);
           closefile(f);

           if bautosmooth then
           begin
           dx:=(ox2-ox1)/(smMx-1);
           dy:=(oy2-oy1)/(smMy-1);
           assignfile(f,newName(UTF8decode(FileNameOpenEditor.filename),'_wavemap','grd'));
           rewrite(f);
           writeln(f,'DSAA');
           writeln(f, smMx,' ',smMy);
           writeln(f, ox1,' ',ox2);
           writeln(f, -oy2,' ',-oy1);
           writeln(f,smmin,' ',smmax);
           y:=oy1;
           for k:=smMy downto 1 do
           begin
           x:=ox1;
           for i:=1 to smMx do
           begin
           write(f,smMap[i,k],' ');
           x:=x+dx;
           end;
           y:=y+dy;
           end;
           closefile(f);
           end;

           end;
           LabelNfiles.Visible:=false;
           ProgressBarAuto.Position:=ProgressBarAuto.Min;
           end;


 procedure TMainForm.ButtonSmoothClick(Sender: TObject);
           var k:integer;
           begin
           with TformSmooth.Create(self) do
           begin
           Hide;

           if ShowModal = mrOK then
           begin
           bsmooth:=true;
           bsmoothshow:=true;
           CheckGroupShow.Checked[1]:=true;
           CheckGroupShow.CheckEnabled[1]:=true;
           end;
           
           Free;
           end;
           pbmap.Refresh;
           //refreshMap(self);
           end;

 procedure TMainForm.ButtonStopClick(Sender: TObject);
           begin
           check.bstop:=true;
           LabelNfiles.Visible:=false;
           end;


 procedure TMainForm.CheckGroupShowItemClick(Sender: TObject; Index: integer);
           begin
           bmapshow:=CheckGroupShow.Checked[0];
           bsmoothshow:=CheckGroupShow.Checked[1];
           bsourceshow:=CheckGroupShow.Checked[2];
           bwavebar:=CheckGroupShow.Checked[3];
           refreshMap(Self);
           end;

procedure TMainForm.OpenBottonClick(Sender: TObject);
          var sfile:string;
              f:textfile;
          begin
          sfile:=UTF8Decode(FileNameOpenEditor.filename);
          if (sfile = '') or
          (not FileExists(sfile))
          then exit;
          //if not opendialog.Execute then exit;
          
          
          LoadParameters('gravimagic.ini');
          LoadCoeDat(sfile);
          TabDat;
          bdat:=true;
          bkarkas:=false;
          bmap:=false;
          bgrid:=false;
          bsource:=false;
          bsmooth:=false;
          
          bmapshow:=false;
          CheckGroupShow.Checked[0]:=false;
          CheckGroupShow.CheckEnabled[0]:=false;
          bsourceshow:=false;
          CheckGroupShow.Checked[1]:=false;
          CheckGroupShow.CheckEnabled[1]:=false;
          bsmoothshow:=false;
          CheckGroupShow.Checked[2]:=false;
          CheckGroupShow.CheckEnabled[2]:=false;
          bwavebar:=false;
          CheckGroupShow.Checked[3]:=false;
          CheckGroupShow.CheckEnabled[3]:=false;

          
          
          if bkarkas then check.Done;
          
          with check do
          begin
          Create;
          Loadset;
          LoadData;
          Create_medium;
          PsiTabulation;
          PutToNewData(ProgressWave);
          //PlotData(3);
          Maxnsources:=3;
          ncycles:=200;
          nsensor:=1;
          end;
          buttonSmooth.Enabled:=false;
          buttonExport.Enabled:=true;


          bkarkas:=true;
          buttonWave.Enabled:=true;
          buttonsources.Enabled:=true;
          labelCountm.Caption:='W-coefficiens: '+ inttostr(check.m);
          labelCountScales.Caption:='scales: '+ inttostr(check.tower);
          labelnsources.caption:='sources: ';
          LabelWMNK.Caption:='W-residual: ';
          LabelMNK.Caption:='residual: ';

          PBmap.Refresh;
          PBplot.Refresh;

          end;

procedure TMainForm.ButtonWaveClick(Sender: TObject);
          var i,k,j,ca:integer;
              x,xo,h,ho,dens,c:double;
              amax,amin:double;
              f:textfile;
              am,h1,h2:double;
          begin
          if not bkarkas then exit;
          amin:=+1e25;
          amax:=-1e25;
          with check do
          for i:=1 to m do
          begin
          if finish[i,4]>amax then amax:=finish[i,4];
          if finish[i,4]<amin then amin:=finish[i,4];
          end;

          with TformFilterDialog.Create(self) do
          begin
          Hide;
          with check do
          begin
          FloatSpinEditH1.Value:=oy1+(oy2-oy1)/10;
          FloatSpinEditH2.Value:=oy1+(oy2-oy1)/2;
          FloatSpinEditAmp.Value:=max(abs(amax),abs(amin));
          MinAmplitude:=FloatSpinEditAmp.Value;
          end;


          case RadioGroup1.ItemIndex of
          0:begin FloatSpinEditH1.visible:=true; Label1.Visible:=true; FloatSpinEditH2.visible:=false;label2.Visible:=false;end;
          1:begin FloatSpinEditH1.visible:=true; Label1.Visible:=true; FloatSpinEditH2.visible:=true; label2.Visible:=true;end;
          2:begin FloatSpinEditH1.visible:=false;Label1.Visible:=false;FloatSpinEditH2.visible:=true; label2.Visible:=true;end;
          end;
          label7.Caption:=Floattostrf(check.oy2,ffgeneral,6,2);
          Label3.Caption:='keep ('+inttostr(round((check.MinAmplitude-FloatSpinEditAmp.Value)/check.MinAmplitude*100))+'%)';
          CheckBoxSaveChange(Self);
          CheckBoxNilChange(Self);
          if ShowModal = mrOK then
          begin

          with check do
          begin
          H1:=FloatSpinEditH1.Value;
          H2:=FloatSpinEditH2.Value;
          am:=FloatSpinEditAmp.Value;
          ca:=RadioGroup1.ItemIndex;

          if not CheckBoxLevel.Checked then am:=1e10;

          if not CheckBoxNil.Checked
          then
          begin
          //PutToNewData(ProgressWave);
          Filter(ca,H1,H2,am);
          for i:=1 to n do dat[i,3]:=Direct(getx(i),4)+Zshift;
          end
          else PutToNewData(ProgressWave);


          vmx:=pbmap.Width div 2;
          vmy:=pbmap.Height div 4;
          TabVMap;

          if nsources>0 then
          begin

          for i:=1 to vmx do
          begin
          x:=getxvmap(i);
          for k:=1 to vmy do
          begin
          h:=getyvmap(k);

          c:=0;
          for j:=1 to nsources do
          begin
          xo:=source[j,1];
          ho:=source[j,2];
          dens:=source[j,3];
          c:=c+iWav(x-xo,h,ho,dens);
          end;{j}

          vmap[i,k]:=vmap[i,k]-c;
          end;{k}
          end;{i}


          vmapmin:=+1e10;
          vmapmax:=-1e10;
          for i:=1 to vmx do
          for k:=1 to vmy do
          begin
          c:=vmap[i,k];
          if vmapmin>c then vmapmin:=c;
          if vmapmax<c then vmapmax:=c;
          end;
          end;

          for k:=1 to npalettemap do iso[k]:=(vmapmin)+(k-1)*(vmapmax-vmapmin)/(npalettemap-1);
          //VisualMap(PBmap,vmap,vmx,vmy,iso,npalettemap,vmapmin,vmapmax);
          bmap:=true;
          bmapshow:=true;
          CheckGroupShow.Checked[0]:=true;
          CheckGroupShow.CheckEnabled[0]:=true;

          end; {with check}

          if CheckBoxSave.Checked then
          begin
          assignfile(f,UTF8Decode(FileNameEditfilter.FileName));
          rewrite(f);
          for k:=1 to ndat do
          writeln(f,dat[k,1],' ',dat[k,2],' ',dat[k,3]);
          closefile(f);
          end;

          end;{if ShowModal = mrOK}

          Free;
          end; {with TformFilterDialog.Create(self)}
          refreshMap(self);
          //pbmap.Refresh;

          end;


procedure TMainForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
          begin
          if bkarkas then check.done;
          end;

procedure TMainForm.RefreshMap(Sender: TObject);
          begin
          if not bdat then exit;
          application.ProcessMessages;
          if bdat then begin pbmap.Canvas.Lock; PlotData(2); pbmap.Canvas.Unlock; end;
          if bkarkas then begin pbmap.Canvas.Lock; PlotData(3); pbmap.Canvas.Unlock; end;

          if bmapshow then with check do begin pbplot.Canvas.Lock; VisualMap(PBmap,vmap,vmx,vmy,iso,npalettemap,vmapmin,vmapmax); pbplot.Canvas.Unlock; end
          else
          if not bsmoothshow then
          with PBmap.canvas do
          begin
          brush.color:=clwhite;
          pen.color:=clMedGray;
          rectangle(0,0,PBmap.width,PBmap.height);
          end;

          if bsmoothshow then with check do
          VisualMap(PBmap,smmap,smmx,smmy,smiso,npalettemap,smmin,smmax);

          if bsourceshow then
          with check do
          begin
          VisualSources(PBmap,source,nsources,ox1,ox2,oy1,oy2);
          //VisualPost(PBmap,finish,m,ox1,ox2,oy1,oy2,clgreen);
          TabDat5col;
          PlotData(5);
          end;
          if bwavebar then with check do VisualWaveBar(PBmap,ox1,ox2,oy1,oy2);
          end;

procedure TMainForm.ButtonexportClick(Sender: TObject);
          begin
          if not bgrid then
          with Tformexport.Create(self) do
          begin
          with check do label_s.Caption:='N = '+inttostr(nsources);
          Hide;

          if ShowModal = mrOK then
          Begin
          End;
          Free;
          end;

          end;



procedure TMainForm.PBmapMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
          var xi,hi:double;
          begin
          with check do
          begin
          xi:=ox1+x/pbmap.Width*(ox2-ox1);
          hi:=oy1+y/pbmap.Height*(oy2-oy1);
          PBmap.Hint:='x = '+floattostrf(xi,ffgeneral,4,4)+', h = '+floattostrf(hi,ffgeneral,4,4);
          end;
          end;

procedure TMainForm.PBmapPaint(Sender: TObject);
          begin
          RefreshMap(Self);
          end;



procedure TMainForm.PBplotPaint(Sender: TObject);
          begin
          RefreshMap(Self);
          end;



procedure TMainForm.RadioGroupGeomethodClick(Sender: TObject);
          begin
          case RadioGroupGeomethod.ItemIndex of
          0: Geomethod:=1;
          1: Geomethod:=2;
          2: Geomethod:=3;
          end;
          //showmessage('Geomethod: '+inttostr(Geomethod));
          end;



procedure TMainForm.ButtonSourcesClick(Sender: TObject);
          var b1,b2,b3:boolean;
          var k:integer;
          begin
          if not bgrid then
          with TFormGrid.Create(self) do
          begin
          Hide;

          if ShowModal = mrOK then
          Begin

          with check do
          begin
          labelnsources.caption:='sources: ';
          LabelWMNK.Caption:='W-residual: ';

          //check.checkopti:=CheckBoxoptimal.Checked;
          ncycles:=SpinEditncycles.Value;
          nsensor:=FloatSpinEditnsensor.Value;

          bsource:=true;
          bsourceshow:=true;
          CheckGroupShow.Checked[2]:=true;
          CheckGroupShow.CheckEnabled[2]:=true;

          bwavebar:=true;
          CheckGroupShow.Checked[3]:=true;
          CheckGroupShow.CheckEnabled[3]:=true;

          b1:=bmapshow;bmapshow:=false;
          b2:=bsmoothshow;bsmoothshow:=false;
          b3:=bwavebar;bwavebar:=false;
          buttonstop.Visible:=true;
          bstop:=false;
          RefreshMap(Nil);
          SearchAll(ProgressWave,LabelInfo,Labelnsources,LabelWMNK,LabelMNK);
          bstop:=false;
          buttonstop.Visible:=false;

          bmapshow:=b1;
          bsmoothshow:=b2;
          bwavebar:=b3;
          bgrid:=false;
          buttonSmooth.Enabled:=true;
          RefreshMap(Nil);
          end;

          End;
          Free;
          end;
          end;


procedure TMainForm.PlotData(k:integer);
          var i:integer;
              xi,yi:integer;
              wbar,hbar:integer;
              oty,otx:integer;
          Begin
          oty:=4;
          otx:=4;
          wbar:=PBplot.Width -2*otx;
          hbar:=PBplot.Height-2*oty;

          xi:=round(otx+(dat[1,1]-datxmin)/(datxmax-datxmin)*wbar);
          yi:=round(hbar+oty-(dat[1,k]-datymin)/(datymax-datymin)*hbar);

          with PBplot.Canvas do
          begin
          Pen.color:=clSilver;
          Brush.color:=clwhite;

          if k=2 then rectangle(0,0,wbar+2*otx,hbar+2*oty);

          Pen.style:=pssolid;
          case k of
          2:Pen.color:=clblue;
          3:Pen.color:=clRed;
          5:Pen.color:=clBlack;
          end;
          Pen.Width:=1;

          moveto(xi,yi);
          for i:=1 to ndat do
          Begin
          xi:=round(otx+(dat[i,1]-datxmin)/(datxmax-datxmin)*wbar);
          yi:=round(hbar+oty-(dat[i,k]-datymin)/(datymax-datymin)*hbar);

          lineto(xi,yi);

          //Brush.color:=clLime;
          //ellipse(xi-2,yi-2,xi+2,yi+2);

          end;
          Pen.Width:=1;


          end;{with}
          End;
          
procedure Tmainform.GetRGBColor(sColor: TColor; out R,G,B:Byte);
          begin
          R := Color and $FF;
          G := (Color and $FF00) shr 8;
          B := (Color and $FF0000) shr 16;
          end;

function  Tmainform.PutRGBColor(R,G,B:byte):Tcolor;
          begin
          result:=(r or (g shl 8) or (b shl 16));
          end;

procedure TMainForm.Splitter1CanResize(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
          begin

          pbplot.Top:=0;
          pbplot.left:=1;
          pbplot.Width:=Panel3.Width-2;
          pbplot.Height:=Splitter1.Top-1;

          pbmap.Top:=Splitter1.Top+Splitter1.Height+1;
          pbmap.Left:=1;
          pbmap.Width:=Panel3.Width-2;
          pbmap.Height:=Panel3.Height-Splitter1.Height-pbplot.Height;

          hr:=pbplot.Height/pbmap.Height;
          end;

procedure TMainForm.Splitter1Moved(Sender: TObject);
          begin
          pbplot.Top:=0;
          pbplot.left:=1;
          pbplot.Width:=Panel3.Width-2;
          pbplot.Height:=Splitter1.Top-1;

          pbmap.Top:=Splitter1.Top+Splitter1.Height+1;
          pbmap.Left:=1;
          pbmap.Width:=Panel3.Width-2;
          pbmap.Height:=Panel3.Height-Splitter1.Height-pbplot.Height;

          hr:=pbplot.Height/pbmap.Height;
          end;



procedure Tmainform.PutCell(i,k:longint;dx,dy:double;var map:TMapArray;var Cell:Tcell);
          Begin
          cell[1,1]:=(i-1)*dx;
          cell[2,1]:=(i-0)*dx;
          cell[3,1]:=(i-0)*dx;
          cell[4,1]:=(i-1)*dx;
          cell[1,2]:=(k-1)*dy;
          cell[2,2]:=(k-1)*dy;
          cell[3,2]:=(k-0)*dy;
          cell[4,2]:=(k-0)*dy;
          cell[1,3]:=map[i+0,k+0];
          cell[2,3]:=map[i+1,k+0];
          cell[3,3]:=map[i+1,k+1];
          cell[4,3]:=map[i+0,k+1];
          End;
          
procedure Tmainform.FillPalette;
          var i:integer;
              s:double;
          Begin
          for i:=0 to 255 do
          begin
          {
          paletteMap[i,1]:=round( (1+cos(-0.1+(255-i)/255*pi*1.5))/2*255 );
          paletteMap[i,2]:=round( (1+sin(-0.1+(255-i)/255*pi*1.5))/2*255 );
          paletteMap[i,3]:=round( (255-i));
          }
          paletteMap[i,1]:=i;
          paletteMap[i,2]:=paletteMap[i,1];
          paletteMap[i,3]:=paletteMap[i,1];


          end;
          End;

procedure TMainForm.FormCreate(Sender: TObject);
          var b1,b2:boolean;
          begin
          npalettemap:=40;
          FillPalette;
          bdat:=false;
          bkarkas:=false;
          bmap:=false;
          bgrid:=false;
          bsource:=false;
          bsmooth:=false;
          buttonSmooth.Enabled:=false;
          buttonExport.Enabled:=false;

          bmapshow:=false;
          CheckGroupShow.Checked[0]:=false;
          CheckGroupShow.CheckEnabled[0]:=false;
          bsourceshow:=false;
          CheckGroupShow.Checked[1]:=false;
          CheckGroupShow.CheckEnabled[1]:=false;
          bsmoothshow:=false;
          CheckGroupShow.Checked[2]:=false;
          CheckGroupShow.CheckEnabled[2]:=false;
          bwavebar:=false;
          CheckGroupShow.Checked[3]:=false;
          CheckGroupShow.CheckEnabled[3]:=false;
          geomethod:=1;
          progresswave.Color:=clHighlight;
          progressBarauto.Color:=clHighlight;
          hr:=1/1.72;
          bsmoothshow:=true;
          p1:=2;
          p2:=1;
          end;


function  Tmainform.GetCellmin(Cell:Tcell):double;
          var cmin,cmax:double;
              i:word;
          Begin
          cmin:=1e10;
          cmax:=-1e10;
          for i:=1 to 4 do
          begin
          if cell[i,3]>cmax then cmax:=cell[i,3];
          if cell[i,3]<cmin then cmin:=cell[i,3];
          end;
          GetCellmin:=cmin;
          End;


function  Tmainform.CellPutPolygonIso(var Cell:Tcell;yb:integer;iso:double;var points:array of TPoint;var len:word):boolean;
          var i,k,t,j,l:word;
              cmin,cmax,xo,yo,zo,dx,dy,dz:double;
              ti:array[1..2,1..2] of word;
              xy:array [1..2] of Tpoint;
          Begin
          cmin:=1e10;
          cmax:=-1e10;


          for i:=1 to 4 do
          begin
          if cell[i,3]>cmax then cmax:=cell[i,3];
          if cell[i,3]<cmin then cmin:=cell[i,3];
          end;

          if ((cmin>iso) or (cmax<=iso)) or (cmax=cmin) then begin CellPutPolygoniso:=false;exit;end
          else CellPutPolygoniso:=true;

          k:=0;
          for i:=1 to 4 do
          begin
          if i=4 then t:=1 else t:=i+1;

          if ((cell[i,3]> cell[t,3]) and (iso< cell[i,3]) and (iso>=cell[t,3])) or
             ((cell[i,3]<=cell[t,3]) and (iso>=cell[i,3]) and (iso< cell[t,3]))
          then
          begin
          k:=k+1;
          ti[k,1]:=i;
          ti[k,2]:=t;
          end;{if}
          if (k>1) then break;
          end;{i}


          for i:=1 to k do
          begin
          xo:=cell[ti[i,1],1];
          yo:=cell[ti[i,1],2];
          zo:=cell[ti[i,1],3];
          dz:=(cell[ti[i,2],3]-cell[ti[i,1],3]);
          dx:=(cell[ti[i,2],1]-cell[ti[i,1],1]);
          dy:=(cell[ti[i,2],2]-cell[ti[i,1],2]);
          xy[i].x:=round(xo + dx / dz*( iso-zo ));
          xy[i].y:=round(yo + dy / dz*( iso-zo ));
          end;

          j:=0;
          for i:=1 to 4 do
          begin
          if i=4 then t:=1 else t:=i+1;

          if (cell[i,3]>=iso) then
          begin
          j:=j+1;
          points[j-1].x:=round(cell[i,1]);
          points[j-1].y:={yb-}round(cell[i,2]);
          end;

          for l:=1 to k do
          if (ti[l,1]=i) and (ti[l,2]=t) then
          begin
          j:=j+1;
          points[j-1].x:=xy[l].x;
          points[j-1].y:={yb-}xy[l].y;
          end;{if}

          end;{i}

          points[j].x:=points[0].x;
          points[j].y:=points[0].y;

          len:=j+1;
          if len<4 then CellPutPolygoniso:=false else CellPutPolygoniso:=true;
          End;

procedure Tmainform.VisualMap(var PB:TPaintBox;var map:TMapArray;nx,ny:longint;var tiso:Tisoarray;niso:longint;tmin,tmax:double);
          var i,k,t:longint;
              d:double;
              cell:Tcell;
              s:integer;
              len:word;
              points:array of Tpoint;
              dx,dy:double;
              cl:Tcolor;

          Begin
          with PB.Canvas do
          begin
          dx:=(PB.width-1)/(nx-1);
          dy:=(PB.height-1)/(ny-1);
          pen.style:=pssolid;
          for k:=1 to ny-1 do
          begin
          for i:=1 to nx-1 do
          begin

          PutCell(i,k,dx,dy,map,Cell);

          for t:=1 to niso do
          begin
          d:=getCellmin(cell);
          if (d>=tiso[t]) and (d<tiso[t+1])
          then
          begin
          s:=round((tiso[t]-(tmin))/(tmax-tmin)*255);
          if s<0 then s:=0;
          if s>255 then s:=255;
          cl:=PutRGBColor(paletteMap[s,1],paletteMap[s,2],paletteMap[s,3]);
          brush.color:=cl;
          pen.color:=cl;
          Rectangle(round((i-1)*dx),round({PB.height-1-}(k-0)*dy),round((i-0)*dx),round({PB.height-1-}(k-1)*dy));
          break;
          end;

          end;{t}

          if (d<tiso[1]) and (d<tiso[t+1])
          then
          begin
          cl:=PutRGBColor(paletteMap[0,1],paletteMap[0,2],paletteMap[0,3]);
          brush.color:=cl;
          pen.color:=cl;
          Rectangle(round((i-1)*dx),round({PB.height-1-}(k-0)*dy),round((i-0)*dx),round({PB.height-1-}(k-1)*dy));
          end;

          if (d>tiso[niso])
          then
          begin
          cl:=PutRGBColor(paletteMap[255,1],paletteMap[255,2],paletteMap[255,3]);
          brush.color:=cl;
          pen.color:=cl;
          Rectangle(round((i-1)*dx),round({PB.height-1-}(k-0)*dy),round((i-0)*dx),round({PB.height-1-}(k-1)*dy));
          end;

          for t:=1 to niso do
          begin
          SetLength(points,8);
          if CellPutPolygonIso(Cell,PB.height-1,tiso[t],points,len)
          then
          begin
          s:=round((tiso[t]-(tmin))/(tmax-tmin)*255);
          if s<0 then s:=0;
          if s>255 then s:=255;

          cl:=PutRGBColor(paletteMap[s,1],paletteMap[s,2],paletteMap[s,3]);
          brush.color:=cl;
          pen.color:=cl;
          SetLength(points,len);
          polygon(points,false);
          end;
          end;{t}

          end;{i}
          end;{k}
          pen.color:=clblack;
          brush.style:=bsclear;
          rectangle(0,0,pb.width,pb.height);
          brush.style:=bssolid;
          end;{pb.canvas}
          End;


procedure Tmainform.VisualPost(var PB:TPaintBox;var sfinish:TfinishArray;nf:longint;sx1,sx2,sy1,sy2:double;cl:Tcolor);
          var i:longint;
              x,y:integer;
              wbar,hbar:integer;

          Begin
          with PB.Canvas do
          begin
          Brush.color:=cl;
          wbar:=PB.Width-1;
          hbar:=PB.Height-1;

          for i:=1 to nf do
          begin
          x:=round((sfinish[i,1]-sx1)/(sx2-sx1)*wbar);
          y:=round((sfinish[i,2]-sy1)/(sy2-sy1)*hbar);
          ellipse(x-2,y-2,x+2,y+2);
          end;

          end;{pb.canvas}
          End;

procedure Tmainform.VisualSources(var PB:TPaintBox;var sfinish:TfinishArray;nf:longint;sx1,sx2,sy1,sy2:double);
          var i,r:longint;
              x,y:integer;
              wbar,hbar:integer;
              max,min,z:double;
              colm,colp:Tcolor;

          Begin
          colm:=clBlue;
          colp:=clred;
          max:=-1e10;
          min:=+1e10;
          for i:=1 to nf do
          begin
          if sfinish[i,4]>max then max:=sfinish[i,4];
          if sfinish[i,4]<min then min:=sfinish[i,4];
          end;
          if abs(min)>abs(max) then max:=abs(min) else max:=abs(max);
          
          with PB.Canvas do
          begin
          wbar:=PB.Width-1;
          hbar:=PB.Height-1;

          for i:=1 to nf do
          begin
          x:=round((sfinish[i,1]-sx1)/(sx2-sx1)*wbar);
          y:=round((sfinish[i,2]-sy1)/(sy2-sy1)*hbar);

          z:=sfinish[i,4];
          r:=round(1+abs(z/max)*10);

          if z>0
          then begin Brush.color:=colp;pen.color:=colp;end
          else begin Brush.color:=colm;pen.color:=colm;end;

          ellipse(x-r,y-r,x+r,y+r);
          end;

          end;{pb.canvas}
          End;

procedure Tmainform.VisualWaveBar(var PB:TPaintBox;sx1,sx2,sy1,sy2:double);
          var x1,y1,x2,y2,x3,x4,dx:integer;
              wbar,hbar:integer;

          Begin

          with PB.Canvas do
          begin
          wbar:=PB.Width-1;
          hbar:=PB.Height-1;
          with check do
          begin
          dx:=round(2*wy2*(gmx-1)/(wx2-wx1)+1);
          x1:=round((wx1-sx1)/(sx2-sx1)*wbar);
          y1:=round((wy1-sy1)/(sy2-sy1)*hbar);
          x2:=round((wx2-sx1)/(sx2-sx1)*wbar);
          y2:=round((wy2-sy1)/(sy2-sy1)*hbar);
          x3:=x1+dx;
          x4:=x2-dx;
          end;
          Brush.style:=bsclear;
          pen.color:=clyellow;
          Rectangle(x1,y1,x2,y2);
          line(x1,y1,x3,y2);
          line(x2,y1,x4,y2);
          Brush.style:=bssolid;
          end;{pb.canvas}
          bwavebar:=true;
          CheckGroupShow.Checked[3]:=true;
          CheckGroupShow.CheckEnabled[3]:=true;

          End;


procedure Tmainform.TabDat5col;
          var x,xo,y,z,s,t,mean2,mean5:double;
              i,k:integer;
          Begin
          with check do
          begin
          for i:=1 to ndat do
          begin
          xo:=dat[i,1];
          s:=0;
          for k:=1 to nsources do
          begin
          x:=source[k,1];
          y:=source[k,2];
          z:=source[k,4];

          case geomethod of
        1:s:=s+2*6.67*z*y/(sqr(x-xo)+sqr(y));
        2:s:=s+2*z*(sqr(y)-sqr(x-xo))/sqr(sqr(x-xo)+sqr(y));
        3:begin
          t:=(xo-x)/y;
          s:=s+z*exp(-sqr(t)/2);
          end;
          end;{case}
          end;{k}
          dat[i,5]:=s;
          end;{i}
          mean2:=0;
          mean5:=0;
          for i:=1 to ndat do
          begin
          mean2:=mean2+dat[i,2];
          mean5:=mean5+dat[i,5];
          end;
          mean2:=mean2/ndat;
          mean5:=mean5/ndat;
          for i:=1 to ndat do dat[i,5]:=dat[i,5]+mean2-mean5;
          end;
          End;



initialization
  {$I main.lrs}
end.

