 Unit Mathwave;

 INTERFACE Uses crt,math,loadcoe,
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs,
  EditBtn, Buttons, Spin, ExtCtrls, StdCtrls,ComCtrls,SyncObjs;

Type
    TMyThread = class(TThread)
    private
    procedure Prog;
    protected
    procedure Execute; override;
    public
    constructor Create;
    end;

Type
    TCalcThread = class(TThread)
    private
    procedure Prog;
    protected
    procedure Execute; override;
    public
    constructor Create;
    end;

Type
    TRecalcThread = class(TThread)
    private
    procedure Prog;
    protected
    procedure Execute; override;
    public
    constructor Create;
    end;


var iglobal : word;
    kglobal : word;
    yglobal : double;
    bglobal : boolean;
    CriticalSection: TCriticalSection;


const   nkernel =4;
var chotdog,rhotdog:array[1..nkernel+1] of integer;


 type
 TMapArray = array [1..1001,1..901] of double;
 TfinishArray = array [1..20000,1..4] of double;
 
 var set_name:string;

 type tcheck = object

                    n : longint;  {число точек в исходном массиве}
                    m : longint;  {число w-коэффициентов}
                   cr : word;     {число циклов}
                tower : longint;  {число разбиений по a}
                  psi : array[1..2501] of double;{массив протабулиованного вейвлета}
             minimize : double;     {начальное значение масштаба}
                 xmin : double;     {начальное значение по x}
                 xmax : double;     {конечное  значение по x}
                 step : longint;  {текущий масштаб}
                xa,xb : double;     {нач/кон точки профиля}
               finish : TfinishArray;   {массив значений координат x (1),вейвлета (2) и конечной функции (3)}
               nlayer : array [1..100] of word; {число w-точек в слое}
            bandlimit : double;     {пределы интеграла}
                 Nint : longint;  {число разбиений в интеграле}
                 norm : double;   {нормировка}
                scale : double;   {кратность роста масштаба при разбиении}
                shift : double;   {сдвиг начальной (левой) точки}
                Tstep : double;   {параметр частоты точек в слое}
               dlimit : double;   {доля выхода за пределы профиля}

                 coly : longint;  {текущая колонка с y}
                 colb : longint;  {буфер-колонка}
                 

                 vmap : TMapArray;{матрица визуальной карты}
      vmapmin,vmapmax : double;{мин/макс в матрице визуальной карты}
              vmx,vmy : word; {разбиений в матрице визуальной карты}
      wx1,wx2,wy1,wy2 : double;{расчетные координаты}
      ox1,ox2,oy1,oy2 : double;{графические координаты}

                 gmap : TMapArray;{расчетная матрица}
              gmx,gmy : word;{разбиений в расчетной матрице}

       smMap : TMapArray;{плотностная матрица}
       smMx,smMy : word;{разбиений в плотностной матрице}
       smAspect : double; {отношение осей эллипса изолиний}
       smWidth : double; {}
       smmin,smmax:double;

       MinAmplitude,Zshift:double;

       bstop : boolean;           


     Constructor Create;
      Destructor Done;

       function  gety(i,k:longint):double;
       procedure puty(i,k:longint;y:double);
       function  getx(i:longint):double;

       function  LoadSet:boolean;
       function  LoadData:boolean;

       function  foss(x:double):double;
       function  Wav(x:double):double;
       procedure PsiTabulation;
       procedure Create_medium;{заполнение координат точек сети}

       function  getxlayer(i,k:longint):double;
       function  getylayer(i,k:longint):double;
       function  getzlayer(i,k:longint):double;
       function  fossLayer(t:word;x:double):double;
       function  GetIndexLayer(nmax:longint;y:double):longint;
       procedure GetPosition(x,y:double;var i,k:longint);
       function  fossSurface(x,y:double):double;
       procedure TabVMap;
       procedure TabGMap(var pr:TprogressBar; var sLabel:Tlabel);
       function  getzgmap(i,k:integer):double;
       function  getxgmap(i:integer):double;
       function  getygmap(k:integer):double;
       function  getxvmap(i:integer):double;
       function  getyvmap(k:integer):double;

       function  Svertka(a,b:double):double;
       function  Smooth(h,x:double):double;
       function  Direct(xo:double;k:word):double;{решение прямой задачи}
       procedure Calculate;           {решение обратной задачи (последняя колонка - кумулятивная)}
       procedure Recalculate;         {}
       function  Av:double;
       function  Aver(k:longint):double;
       function  St_Dev(k:longint):double;
       function  MNK:double;
       procedure TimeInfo(time,prog:double; var sout1,sout2:string);
       procedure TabFinish(var c:double;var pr:TprogressBar);
       procedure Filter(var stype:integer;var sH1,sH2,sAmp:double);
       procedure PutToNewData(var pr:TprogressBar);

     end;
     

 IMPLEMENTATION uses main;

{==============================Begin=Tcheck==================================}
   Constructor  tcheck.Create;
                Begin
                tower:=50;
                minimize:=0.1;
                xmin:=0;
                xmax:=100;
                bandlimit:=10;
                Nint:=1001;
                norm:=2;
                scale:=2;
                shift:=1/4;
                cr:=10;
                dlimit:=8;
                Tstep:=0.4;

                coly:=2;
                colb:=4;

                gotoxy(1,1);
                textcolor(Lightgray);
                set_name:='gravimagic.ini';

                //vmx:=580 div 6;
                //vmy:=360 div 6;
                
                //smMx:=vmx;
                //smMy:=vmy;

                smMx:=121;
                smMy:=181;
                smAspect:=0.75;
                smWidth:=0.5;

                CriticalSection:=TCriticalSection.Create;
                End;


    Destructor  tcheck.Done;
                Begin
                {dispose(finish,done);}
                CriticalSection.Destroy;
                End;

     function   tcheck.LoadSet:boolean;
                var f:text;
                    c:double;
                Begin
                assign(f,set_name);
                {$I-}
                reset(f);
                {$I+}
                if IOResult<>0
                then
                begin
                writeln('ini-файл не найден');
                halt;
                end;
                reset(f);

                readln(f,c);
                readln(f,c);
                readln(f,c);
                readln(f,c);
                
                readln(f,bandlimit); {пределы интеграла}
                readln(f,Nint);      {число разбиений в интеграле}
                readln(f,norm);      {нормировка}
                readln(f,scale);     {кратность роста масштаба при разбиении}
                readln(f,shift);     {сдвиг начальной (левой) точки}
                readln(f,cr);        {число циклов}
                readln(f,dlimit);    {доля выхода за пределы профиля}
                readln(f,Tstep);     {параметр частоты точек в слое}
                readln(f,p1);
                readln(f,p2);

                close(f);
                End;

      function  tcheck.gety(i,k:longint):double;
                Begin
                gety:=dat[i,k];
                End;

     procedure  tcheck.puty(i,k:longint;y:double);
                Begin
                dat[i,k]:=y;
                End;

      function  tcheck.getx(i:longint):double;
                Begin
                getx:=dat[i,1];
                End;

      function  tcheck.Loaddata:boolean;
                var   i : longint;
                      sx: longint;
                      sy: longint;
                      c : double;
                Begin
                loaddata:=true;

                n:=ndat;
                xa:=getx(1);
                xb:=getx(n);

                minimize:=(xb-xa)/(n-1);
                xmin:=xa-(xb-xa)/dlimit;  
                xmax:=xb+(xb-xa)/dlimit;
                //xmax:=xa;              
                //xmin:=xb;
                for i:=1 to n do puty(i,colb,gety(i,coly));
                Loaddata:=true;
                End;



      function  tcheck.foss(x:double):double;
                var k:longint;
                y1,y2:double;
                x1,x2:double;
                xi:double;
                Begin
                xi:=x;
                k:=trunc((n-1)*(x-xa)/(xb-xa))+1;

                if (k<1)
                then
                begin
                foss:=gety(1,colb);
                exit;
                end;

                if (k+1>n)
                then
                begin
                foss:=gety(n,colb);
                exit;
                end;
                y1:=gety(k+0,colb);
                y2:=gety(k+1,colb);
                x1:=getx(k+0);
                x2:=getx(k+1);

                foss:=(y2*(xi-x1)-y1*(xi-x2))/(x2-x1);
                End;


     procedure  tcheck.Create_medium;
                var i,k,p,c:longint;
                    y,x,dx:double;
                Begin
                for i:=1 to 10000 do finish[i,4]:=0;
                m:=0;
                c:=0;
                for k:=1 to tower do
                begin
                y:=minimize*intpower(scale,k-1);

                x:=xmin+Tstep*shift*(y-1);
                dx:=y*Tstep;
                if (x>=xmax) or (y>(xmax-xmin))
                then break else p:=trunc((xmax-x)/dx)+1;
                m:=m+p;
                for i:=1 to p do
                begin
                c:=c+1;
                finish[c,1]:=x;
                finish[c,2]:=y;
                x:=x+dx;
                end;
                nlayer[k]:=p;
                end;{k}
                tower:=k;

                ox1:=xa;
                ox2:=xb;
                //oy1:=getylayer(1,1);
                oy1:=0;
                oy2:=oy1+(xb-xa)/580*304;

                wx1:=xa;
                wx2:=xb;
                wy1:=getylayer(1,1);
                wy2:=getylayer(1,tower-1);


                gmx:=ndat;
                gmy:=round(gmx*(wy2-wy1)/(wx2-wx1));

                End;

                {k-номер слоя}
      function  tcheck.getzlayer(i,k:longint):double;
                var j,t:integer;
                Begin
                t:=0;
                for j:=1 to k-1 do t:=t+nlayer[j];
                getzlayer:=finish[t+i,4];
                End;

                {k-номер слоя}
      function  tcheck.getxlayer(i,k:longint):double;
                var j,t:integer;
                Begin
                t:=0;
                for j:=1 to k-1 do t:=t+nlayer[j];
                getxlayer:=finish[t+i,1];
                End;
                
                {k-номер слоя}
      function  tcheck.getylayer(i,k:longint):double;
                var j,t:integer;
                Begin
                t:=0;
                for j:=1 to k-1 do t:=t+nlayer[j];
                getylayer:=finish[t+i,2];
                End;


       function tcheck.fossLayer(t:word;x:double):double;
                var k:longint;
                y1,y2:double;
                x1,x2:double;
                xi:double;
                Begin
                xi:=x;
                k:=trunc((nlayer[t]-1)*(x-getxlayer(1,t))/(getxlayer(nlayer[t],t)-getxlayer(1,t)))+1;

                if (k<1)
                then
                begin
                fosslayer:=getzlayer(1,t);
                exit;
                end;

                if (k>nlayer[t]-1)
                then
                begin
                fosslayer:=getzlayer(nlayer[t],t);
                exit;
                end;
                y1:=getzlayer(k+0,t);
                y2:=getzlayer(k+1,t);
                x1:=getxlayer(k+0,t);
                x2:=getxlayer(k+1,t);

                fosslayer:=(y2*(xi-x1)-y1*(xi-x2))/(x2-x1);
                End;
                
      function  tcheck.GetIndexLayer(nmax:longint;y:double):longint;
                var i,i1,i2,k,n1,n2,kmax:longint;
                Begin
                kmax:=trunc(ln(nmax)/ln(2));
                n1:=1;
                n2:=nmax;
                for k:=1 to kmax do
                begin

                for i:=1 to 2 do
                begin
                i1:=n1+trunc((i-1)*(n2-n1+1)/2);
                i2:=n1+trunc((i-0)*(n2-n1+1)/2)-1;
                if ((y>getylayer(1,i1)) and (y<getylayer(1,i2)))
                then
                begin
                n1:=i1;
                n2:=i2;
                break;
                end;{if}

                end;{i}
                end;{k}
                for i:=n1 to nmax do
                begin
                if (y<getylayer(1,i)) then break;
                end;

                GetIndexLayer:=i-1;
                End;
                
      procedure tcheck.GetPosition(x,y:double;var i,k:longint);
                Begin
                k:=GetIndexLayer(tower,y);
                i:=trunc((nlayer[k]-1)*(x-getxlayer(1,k))/(getxlayer(nlayer[k],k)-getxlayer(1,k)))+1;
                End;

      function  tcheck.fossSurface(x,y:double):double;
                var i,k:longint;
                    io,ko:longint;
                    i1,i2,di:longint;
                    k1,k2,dk:longint;
                    s,xo,yo,zo,r,t,q:double;
                Begin
                //di:=round(10/Tstep);
                //dk:=round(8/scale);

                di:=round(50/Tstep);
                dk:=round(30/scale);

                ko:=GetIndexLayer(tower,y);
                //GetPosition(x,y,io,ko);

                k1:=ko-dk; if k1<1 then k1:=1;
                k2:=ko+dk; if k2>tower then k2:=tower;

                s:=0;
                for k:=k1 to k2 do
                begin
                io:=trunc((nlayer[k]-1)*(x-getxlayer(1,k))/(getxlayer(nlayer[k],k)-getxlayer(1,k)))+1;
                //GetPosition(x,getylayer(1,k),io,ko);
                i1:=io-di; if i1<1 then i1:=1;
                i2:=io+di; if i2>nlayer[k] then i2:=nlayer[k];
                for i:=i1 to i2 do
                //for i:=1 to nlayer[k] do
                begin
                
                xo:=getxlayer(i,k);
                yo:=getylayer(i,k);
                zo:=getzlayer(i,k);
                if (yo=0) then continue;
                {

                s:=sqr(y)+sqr(yo);
                t:=sqr(x)/s;
                iWav:=zo*sqrt(8*yo*y/s)*yo*y/s*(1-t)*exp(-t/2)
                }
                case geomethod of
             1,2:begin
                r:=y+yo;
                t:=sqr((x-xo)/r);
                q:=sqr(r*(1+t));
                s:=s+1.909*zo*16*power(yo,norm-4)*sqr(yo*y)*(1+sqr(t)-6*t)/sqr(q);
                end;
             3: begin
                r:=y/(sqr(y)+sqr(yo));
                t:=sqr(x-xo)*r/y;
                s:=s+2.5*zo*power(yo,norm-2.5)*yo*r*sqrt(yo*r)*(1-t)*exp(-t/2);
                end;
                end;{case}
                end;{i}
                end;{k}
                
                fossSurface:=s;
                End;

{****************}
      procedure Runs;
                var t,i:word;
                    c,x,dx:double;
                    z:double;
                Begin
                t:=kglobal;
                z:=yglobal;
                with check do
                begin
                dx:=(ox2-ox1)/(vmx-1);
                x:=ox1;
                for i:=1 to vmx do
                begin
                if z=0 then c:=0
                else
                c:=fossSurface(x,z);
                if vmapmin>c then vmapmin:=c;
                if vmapmax<c then vmapmax:=c;
                vmap[i,t]:=c;
                x:=x+dx;
                end;
                end;
                End;

    constructor TMyThread.Create;
                Begin
                inherited Create(true);
                FreeOnTerminate := True;
                Self.Priority := tpHighest;
                End;

      procedure TMyThread.Execute;
                Begin
                bglobal:=true;
                runs;
                End;

      procedure TMyThread.Prog;
                Begin
                Application.ProcessMessages;
                MainForm.ProgressWave.Position:=kglobal;
                end;

                {
     procedure  tcheck.TabVMap;
                var k:word;
                    y,dy:double;
                    my:TMyThread;
                Begin
                application.ProcessMessages;
                MainForm.LabelInfo.Caption:='preparation of data...';
                MainForm.LabelInfo.visible:=true;
                MainForm.ProgressWave.min:=1;
                MainForm.ProgressWave.max:=vmy;

                vmapmin:=+1e10;
                vmapmax:=-1e10;
                dy:=(oy2-oy1)/(vmy-1);
                yglobal:=oy1;
                for kglobal:=1 to vmy do
                begin
                bglobal:=false;
                My:=TMyThread.Create;
                repeat my.Resume until bglobal;
                my.Synchronize(@my.prog);
                yglobal:=yglobal+dy;
                end;{y}

                application.ProcessMessages;
                MainForm.ProgressWave.Position:=MainForm.ProgressWave.min;
                MainForm.LabelInfo.Visible:=false;
                End;
                }

{****************}

     procedure  tcheck.TabVMap;
                var i,k:word;
                    c,x,dx,y,dy:double;
                    f:textfile;
                Begin

                {табуляция  vmap}
                MainForm.LabelInfo.Caption:='preparation of data...';
                MainForm.LabelInfo.visible:=true;

                vmapmin:=+1e10;
                vmapmax:=-1e10;
                
                dx:=(ox2-ox1)/(vmx-1);
                dy:=(oy2-oy1)/(vmy-1);

                MainForm.ProgressWave.min:=1;
                MainForm.ProgressWave.max:=vmy;

                y:=oy1;
                for k:=1 to vmy do
                begin
                MainForm.ProgressWave.Position:=k;
                application.ProcessMessages;
                x:=ox1;
                for i:=1 to vmx do
                begin
                if y=0 then c:=0
                else
                c:=fossSurface(x,y);
                if vmapmin>c then vmapmin:=c;
                if vmapmax<c then vmapmax:=c;
                vmap[i,k]:=c;
                x:=x+dx;
                end;{x}
                y:=y+dy;
                end;{y}

                MainForm.ProgressWave.Position:=MainForm.ProgressWave.min;
                MainForm.LabelInfo.Visible:=false;
                
                {
                assignfile(f,'finish.dat');
                rewrite(f);
                for k:=1 to m do
                writeln(f,finish[k,1],' ',-finish[k,2],' ',finish[k,4]);
                closefile(f);
                }
                End;

      procedure  tcheck.TabGMap(var pr:TprogressBar; var sLabel:Tlabel);
                var i,k:word;
                    c,x,dx,y,dy:double;
                Begin

                slabel.visible:=true;
                {табуляция  gmap}
                slabel.Caption:='calculate of w-series...';
                dx:=(wx2-wx1)/(gmx-1);
                dy:=(wy2-wy1)/(gmy-1);

                pr.min:=1;
                pr.max:=gmy;

                y:=wy1;
                for k:=1 to gmy do
                begin
                pr.Position:=k;
                application.ProcessMessages;
                x:=wx1;
                for i:=1 to gmx do
                begin
                if y=0 then c:=0 else c:=fossSurface(x,y);
                gmap[i,k]:=c;
                x:=x+dx;
                //if bstop then break;
                end;
                y:=y+dy;
                if bstop then break;
                end;
                
                pr.Position:=pr.min;
                slabel.visible:=false;
                End;
                
                
      function  tcheck.getzgmap(i,k:integer):double;
                Begin
                getzgmap:=gmap[i,k];
                End;

      function  tcheck.getxgmap(i:integer):double;
                Begin
                getxgmap:=wx1+(wx2-wx1)/(gmx-1)*(i-1);
                End;

      function  tcheck.getygmap(k:integer):double;
                Begin
                getygmap:=wy1+(wy2-wy1)/(gmy-1)*(k-1);
                End;

      function  tcheck.getxvmap(i:integer):double;
                Begin
                getxvmap:=ox1+(ox2-ox1)/(vmx-1)*(i-1);
                End;

      function  tcheck.getyvmap(k:integer):double;
                Begin
                getyvmap:=oy1+(oy2-oy1)/(vmy-1)*(k-1);
                End;

      function  tcheck.Svertka(a,b:double):double;
                var i:longint;
                    x,h,q:double;
                    x1,x2 :double;
                Begin
                x1:=a;
                x2:=b;

                h:=2*(x2-x1)/Nint;
                q:=foss(x1)*psi[1]+foss(x2)*psi[Nint];

                x:=x1+h/2;
                for i:=1 to (Nint div 2)-0 do
                begin
                q:=q+4*foss(x)*psi[2*i-1];
                x:=x+h;
                end;

                x:=x1+h/1;
                for i:=1 to (Nint div 2)-1 do
                begin
                q:=q+2*foss(x)*psi[2*i-0];
                x:=x+h;
                end;
                Svertka:=h/6*q;
                End;

      function  tcheck.Wav(x:double):double;
                var z:double;
                Begin

                z:=sqr(x);
                case main.geomethod of
                1:wav:=(1+sqr(z)-6*z)/intpower(1+z,4);
                2:wav:=(1-3*z)/intpower(1+z,3);
                3:wav:=(1-z)*exp(-z/2);
                end;
                End;

      procedure tcheck.PsiTabulation;
                var i:word;
                    x,dx:double;
                Begin
                dx:=2*bandlimit/(Nint-1);
                x:=-bandlimit;
                for i:=1 to Nint do
                begin
                psi[i]:=wav(x);
                x:=x+dx;
                end;
                End;

      function  tcheck.Smooth(h,x:double):double;
                var L:double;
                Begin
                if (h=0) then begin Smooth:=0;exit;end;
                case main.geomethod of
                1:L:=Tstep/7.543;
                2:L:=Tstep/7.543*2.1*h;
                3:L:=Tstep/4.5/h;
                end;
                //L:=48/(sqr(pi)*6.67)*Tstep/5.5;
                //L:=Tstep/4.5; {T=0.35 => L=0.07, T=0.4 => L=0.08, T=0.3 => L=0.06}
                Smooth:=L/power(h,norm-2)*Svertka(x-h*bandlimit,x+h*bandlimit);
                End;

    function    tcheck.Direct(xo:double;k:word):double;
                var i:longint;
                    s,x,y,z,t:double;
                Begin
                case main.geomethod of
                
                1:begin
                  s:=0;
                  for i:=1 to m do
                  begin
                  x:=finish[i,1];
                  y:=finish[i,2];
                  z:=finish[i,k];
                  //t:=(xo-x)/y;
                  s:=s+z*y/(sqr(x-xo)+sqr(y));
                  //s:=s+z*exp(-sqr(t)/2);
                  end;
                  s:=s*2*6.67/1.0004;
                  end;{1}
                  
                2:begin
                  s:=0;
                  for i:=1 to m do
                  begin
                  x:=finish[i,1];
                  y:=finish[i,2];
                  z:=finish[i,k];
                  s:=s+z*(sqr(y)-sqr(x-xo))/sqr(sqr(x-xo)+sqr(y));
                  end;
                  s:=s*2;
                  end;{2}
                  
                3:begin
                  s:=0;
                  for i:=1 to m do
                  begin
                  x:=finish[i,1];
                  y:=finish[i,2];
                  z:=finish[i,k];
                  t:=(xo-x)/y;
                  s:=s+z*exp(-sqr(t)/2);
                  end;
                  end;{3}

                end;{case}
                  
                Direct:=s;
                End;

{******************поток*calc*******************}

   constructor TcalcThread.Create;
                Begin
                inherited Create(false);
                FreeOnTerminate := True;
                Self.Priority := tpTimeCritical;
                End;

      procedure Runscalc;
                var i,t:integer;
                begin
                t:=kglobal;
                with check do
                for i:=chotdog[t]+1 to chotdog[t+1] do
                begin
                finish[i,3]:=smooth(finish[i,2],finish[i,1]);
                finish[i,4]:=finish[i,4]+finish[i,3];
                end;
                end;

      procedure TcalcThread.Execute;
                Begin
                RunsCalc;
                CriticalSection.Enter;
                inc(kglobal);
                CriticalSection.Leave;
                End;

      procedure TcalcThread.Prog;
                Begin
                Application.ProcessMessages;
                MainForm.ProgressWave.Position:=iglobal;
                end;

{***************конец*поток*calc****************}

{******************поток*recalc*******************}
   constructor TrecalcThread.Create;
                Begin
                inherited Create(true);
                FreeOnTerminate := True;
                Self.Priority := tpTimeCritical;
                End;

      procedure RunsReCalc;
                var i:integer;
                Begin
                with check do
                for i:=rhotdog[kglobal]+1 to rhotdog[kglobal+1] do
                puty(i,colb,gety(i,colb)-Direct(getx(i),3));
                End;

      procedure TrecalcThread.Execute;
                Begin
                CriticalSection.Enter;
                RunsReCalc;
                CriticalSection.Leave;
                inc(kglobal);

                End;

      procedure TrecalcThread.Prog;
                Begin
                Application.ProcessMessages;
                MainForm.ProgressWave.Position:=iglobal;
                end;

{***************конец*поток*recalc****************}

     procedure  tcheck.Calculate;
                var i:integer;
                    Calc:array[1..nkernel] of TCalcThread;
                Begin
                {
                CriticalSection.Create;
                for i:=1 to nkernel do Calc[i]:=TCalcThread.Create;
                kglobal:=1;
                repeat
                Calc[kglobal]:=TCalcThread.Create;
                sleep(2);
                //calc[kglobal].Synchronize(@calc[kglobal].prog);
                until kglobal>nkernel;
                }

                for kglobal:=1 to nkernel do RunsCalc;
                Application.ProcessMessages;
                MainForm.ProgressWave.Position:=iglobal;

                End;


     procedure  tcheck.Recalculate;
                var  i : integer;
                     recalc : array [1..nkernel] of TReCalcThread;
                Begin
                {
                for i:=1 to nkernel do recalc[i]:=TReCalcThread.Create;
                CriticalSection:=TCriticalSection.Create;
                kglobal:=1;
                for i:=1 to nkernel do
                begin
                recalc[i].Resume;
                end;
                sleep(100);
                Recalc[1].Synchronize(@Recalc[i].prog);
                //ShowMessage(inttostr(iglobal)+' '+inttostr(kglobal-1));
                }

                for kglobal:=1 to nkernel do RunsReCalc;
                MainForm.ProgressWave.Position:=iglobal;

                End;

    function    tcheck.Av:double;
                var i:longint;
                    s:double;
                Begin
                s:=0;
                for i:=1 to n do s:=s+Direct(getx(i),4);
                Av:=s/n;
                End;

    function    tcheck.Aver(k:longint):double;
                var i:longint;
                    s:double;
                Begin
                s:=0;
                for i:=1 to n do s:=s+gety(i,k);
                Aver:=s/n;
                End;

    function    tcheck.St_Dev(k:longint):double;
                var i:longint;s,mean:double;
                Begin
                mean:=aver(k);
                s:=0;
                for i:=1 to n do s:=s+sqr(gety(i,k)-mean);
                St_Dev:=sqrt(s/n);
                End;

    function    tcheck.MNK:double;
                var i:longint;s,m1,m2:double;
                Begin
                s:=0;
                for i:=1 to n do s:=s+sqr( gety(i,3) - gety(i,2) );
                MNK:=sqrt(s/n);
                End;


   procedure    tcheck.TimeInfo(time,prog:double; var sout1,sout2:string);
                Begin
                gotoxy(1,21);
                sout1:='passed    : ' + FloattostrF(time,ffFixed,1,1) + ' min ' + '('+ floattostrF(prog*100,ffFixed,1,1)+'%   ';
                sout2:='remained  : '+ FloattostrF((1-prog)/prog*time,ffFixed,1,1) + ' min.  ';
                End;


   procedure    tcheck.TabFinish(var c:double;var pr:TprogressBar);
                var i,j : longint;
                Begin

                for i:=1 to nkernel do chotdog[i]:=(m div nkernel)*(i-1);
                chotdog[nkernel+1]:=m;

                for i:=1 to nkernel do rhotdog[i]:=(n div nkernel)*(i-1);
                rhotdog[nkernel+1]:=n;

                for j:=1 to m do begin finish[j,3]:=0;finish[j,4]:=0;end;
                for j:=1 to n do puty(j,colb,gety(j,coly));

                pr.min:=1;
                pr.max:=cr;


                for i:=1 to cr do
                begin
                iglobal:=i;
                application.ProcessMessages;
                Calculate;
                Recalculate;
                end;{i}
                
                pr.Position:=pr.min;
                c:=Aver(coly)-av;
                End;
                
   procedure    tcheck.Filter(var stype:integer;var sH1,sH2,sAmp:double);
                var i:longint;
                    z,y:double;
                Begin
                {
                case stype of
                0:showmessage('0');
                1:showmessage('1');
                2:showmessage('2');
                end;
                }
                for i:=1 to m do
                begin
                y:=finish[i,2];
                z:=finish[i,4];
                case stype of
                0:if  ((y>sH1) and (z<sAmp)) then begin finish[i,4]:=0; end;
                1:if  ((y<sH1) or (y>sH2)) and (z<sAmp) then begin finish[i,4]:=0; end;
                2:if  ((y<sH2) and (z<sAmp)) then begin finish[i,4]:=0; end;
                end;
                end;
                End;



   procedure    tcheck.PutToNewData(var pr:TprogressBar);
                var i,k:longint;
                Begin
                TabFinish(Zshift,pr);
                for i:=1 to n do dat[i,3]:=Direct(getx(i),4)+Zshift;
                End;


{================================End=Tcheck==================================}

 Begin
 
 End.

