unit montage;

{$mode objfpc}{$H+}

interface uses Classes, SysUtils,mathwave,crt,math,
               LResources, Forms, Controls, Graphics, Dialogs,
               EditBtn, ExtCtrls, StdCtrls,ComCtrls;

 type Tmontage = object(Tcheck)

     source : TfinishArray;
   nsources : longint;
   
     copysource : TfinishArray;
   ncopysources : longint;

maxnsources : longint;
       disp : double;
      disp0 : double;
   minlevel : double;
   maxlevel : double;
    ncycles : word;
    nsensor : double;
  checkplus : boolean;
 checkminus : boolean;
  checkOpti : boolean;

  

    function  MNK5:double;
    function  WDispersy:double;
    function  WMNK:double;
    function  iWav(x,h,ho,dens:double):double;
   procedure  SourcePut(k:longint;x,h,d:double);
   procedure  Refresh(xo,ho,dens:double);
    function  Extremal(i,k:longint):double;
    function  SearchXY(var it,kt:longint):boolean;
    function  Search2XY(var i1,k1,i2,k2:longint):boolean;
    function  TryAddSource(var i,k:longint):boolean;
    function  Try2AddSource(var i1,k1,i2,k2:longint):boolean;

   procedure  DelSource;
    function  AddSource(var i,k:longint):boolean;
    function  TryMoveSource(t:integer):boolean;
   
   procedure  GetCopySource;
   procedure  PutCopySource;
   procedure  RefreshCopySources;
   
   procedure  SearchAll(var pr:TprogressBar; var slabel1,slabel2,slabel3,slabel4:Tlabel);
   
    function  Lor(x,y:double):double;
   procedure  TabsmMap;

 end;
 
implementation uses main;

  function    Tmontage.MNK5:double;
              var i:longint;s,m1,m2:double;
              Begin
              //Recalculate;
              m1:=0;
              m2:=0;
              s:=0;
              for i:=1 to n do begin m1:=m1+gety(i,2);m2:=m2+gety(i,5);end;
              for i:=1 to n do s:=s+sqr( gety(i,5) - gety(i,2) + m2 - m1 );
              MNK5:=sqrt(s/n);
              End;

    function  Tmontage.WDispersy:double;
              var i,di,k,c:longint;
                  d,s,h:double;
              Begin
              s:=0;
              c:=0;
              for k:=1 to gmy do
              begin
              h:=getygmap(k);
              di:=round(2*h*(gmx-1)/(wx2-wx1)+1);
              if h=0 then continue else
              for i:=di+1 to gmx-di do
              begin
              s:=s+intpower(abs(getzgmap(i,k)),p1)/intpower(h,p2);
              c:=c+1;
              end;{k}

              end;{i}

              if c>0 then WDispersy:=power(s,1/p1)/power(c,1/p2) else WDispersy:=1e10;

              End;

      function  Tmontage.WMNK:double;
                Begin
                if bmnk then result:=mnk5 else result:=Wdispersy;
                End;


      function  Tmontage.iWav(x,h,ho,dens:double):double;
                var s,t,q:double;
                Begin
                case main.geomethod of
            1,2:begin
                s:=h+ho;
                t:=sqr(x/s);
                q:=sqr(s*(1+t));
                iWav:=dens*16*sqr(ho*h)*(1+sqr(t)-6*t)/sqr(q);
                end;
              3:begin
                s:=sqr(h)+sqr(ho);
                t:=sqr(x)/s;
                iWav:=dens*sqrt(8*ho*h/s)*ho*h/s*(1-t)*exp(-t/2);
                end;
                end;{case}
                End;

   procedure    Tmontage.SourcePut(k:longint;x,h,d:double);
                var c:double;
                Begin
                source[k,1]:=x;
                source[k,2]:=h;
                source[k,3]:=d;
                case main.geomethod of
            1,2:source[k,4]:=d*pi*sqr(h)/6;
              3:source[k,4]:=sqrt(4*h/pi)*d;
                end;
                End;

   procedure    Tmontage.Refresh(xo,ho,dens:double);
                var i,j,k:longint;
                    x,y,h:double;
                Begin
                for k:=1 to gmy do
                begin
                for i:=1 to gmx do
                begin
                x:=getxgmap(i);
                h:=getygmap(k);
                gmap[i,k]:=getzgmap(i,k)-iWav(x-xo,h,ho,dens);
                end;
                application.ProcessMessages;
                //MainForm.PBmap.Refresh;
                //MainForm.PBplot.Refresh;
                end;
                End;

    function    Tmontage.Extremal(i,k:longint):double;
                var c11,c12,c13,c21,c22,c23,c31,c32,c33:double;
                    t,m1,m2,d1,d2:double;
                Begin

                c12:=getzgmap(i  ,k-1);
                c32:=getzgmap(i  ,k+1);
                
                c22:=getzgmap(i  ,k  );

                c21:=getzgmap(i-1,k  );
                c23:=getzgmap(i+1,k  );


                if
                (
                ( (c22>c12) and (c22>c21) and (c22>c23) and (c22>c32) )
                or
                ( (c22<c12) and (c22<c21) and (c22<c23) and (c22<c32) )
                )
                then t:=c22
                else t:=0;
                Extremal:=t;
                End;

   function    Tmontage.SearchXY(var it,kt:longint):boolean;
                var i,k:longint;
                    test:double;
                    minmax:double;
                    b:boolean;
                Begin
                b:=false;
                minmax:=-1e10;
                for k:= gmy-2 downto 3 do
                for i:= gmx-2 downto 3 do
                begin
                test:=Extremal(i,k);
                if (test<>0)
                and
                ( (checkplus and (not checkminus) and (test>0)) or (checkminus and (not checkplus) and (test<0)) or (checkminus and checkplus and (test<>0)))
                and
                ((test>maxlevel) or (test<minlevel)) and (abs(test)>minmax)
                then
                begin
                minmax:=abs(test);
                it:=i;
                kt:=k;
                b:=true;
                end;{if}
                end;{i}

                SearchXY:=b;
                End;

   function    Tmontage.Search2XY(var i1,k1,i2,k2:longint):boolean;
                var i,k:longint;
                    test:double;
                    minmax:double;
                    b:boolean;
                Begin
                b:=false;
                minmax:=-1e10;
                i1:=1;
                k1:=1;
                for k:=3 to gmy-2 do
                for i:=3 to gmx-2 do
                begin
                test:=Extremal(i,k);
                if (test<>0)
                and
                ( (checkplus and (test>0)) or (checkminus and (test<0)) )
                and
                ((test>maxlevel) or (test<minlevel)) and (abs(test)>minmax)
                then
                begin
                minmax:=abs(test);
                i2:=i1;
                k2:=k1;
                i1:=i;
                k1:=k;
                b:=true;
                end;{if}
                end;{i}
                if b and ((i2<>1) and (k2<>1)) then Search2XY:=true else Search2XY:=false;
                End;

    function    Tmontage.TryAddSource(var i,k:longint):boolean;
                var d:double;
                    xo,ho,dens:double;
                    ii,kk:integer;
                Begin
                if (not SearchXY(ii,kk)) then begin TryAddSource:=false;exit;end;

                xo:=getxgmap(ii);
                ho:=getygmap(kk);
                dens:=getzgmap(ii,kk);
                i:=ii;
                k:=kk;

                disp:=WMNK;
                Refresh(xo,ho,dens);
                d:=WMNK;
                Refresh(xo,ho,-dens);

                //disp:=d;
                //TryAddSource:=true;
                TryAddSource:=(d<=disp);
                if TryAddSource then disp:=d;
                End;

    function    Tmontage.Try2AddSource(var i1,k1,i2,k2:longint):boolean;
                var d:double;
                    x1,h1,dens1:double;
                    x2,h2,dens2:double;
                Begin
                if (not Search2XY(i1,k1,i2,k2)) then begin Try2AddSource:=false;exit;end;

                x1:=getxgmap(i1);
                h1:=getygmap(k1);
                dens1:=getzgmap(i1,k1);
                x2:=getxgmap(i2);
                h2:=getygmap(k2);
                dens2:=getzgmap(i2,k2);

                disp:=WMNK;
                Refresh(x1,h1,dens1);
                Refresh(x2,h2,dens2);
                d:=WMNK;
                Refresh(x1,h1,-dens1);
                Refresh(x2,h2,-dens2);

                Try2AddSource:=(d<=disp);
                if Try2AddSource then disp:=d;
                End;


   procedure    Tmontage.PutCopySource;
                var i,k:integer;
                Begin
                for i:=1 to nsources do
                for k:=1 to 4 do copysource[i,k]:=source[i,k];
                ncopysources:=nsources;
                End;
                
   procedure    Tmontage.GetCopySource;
                var i,k:integer;
                Begin
                for i:=1 to ncopysources do
                for k:=1 to 4 do source[i,k]:=copysource[i,k];
                nsources:=ncopysources;
                End;
                
   procedure    Tmontage.RefreshCopySources;
                var i:integer;
                Begin
                for i:=1 to nsources do Refresh(source[i,1],source[i,2],-source[i,3]);
                for i:=1 to ncopysources do Refresh(copysource[i,1],copysource[i,2],copysource[i,3]);
                End;


                {
                если найден экстремум (i,k) и при добавлении нового источника дисперсия уменьшается, то
                добавляется источник (массив source), обновляется счетчик дисперсии
                }
     function   Tmontage.AddSource(var i,k:longint):boolean;
                var xo,ho,dens:double;
                begin
                AddSource:=false;
                if TryAddSource(i,k) then
                begin
                xo:=getxgmap(i);
                ho:=getygmap(k);
                dens:=getzgmap(i,k);

                nsources:=nsources+1;
                sourcePut(nsources,xo,ho,dens);
                Refresh(xo,ho,dens);
                AddSource:=true;
                application.ProcessMessages;
                //MainForm.PBmap.Refresh;
                //MainForm.PBplot.Refresh;
                End;

                End;
                
                {
                удаляется источник со случайным номером в списке, обновляется счетчик дисперсии
                }
    procedure   Tmontage.DelSource;
                var x,h,d:double;
                    i,j:integer;
                    t:integer;
                Begin
                t:=round(1+random(nsources-1));
                x:=source[t,1];
                h:=source[t,2];
                d:=source[t,3];
                Refresh(x,h,-d);
                disp:=WMNK;

                for i:=t to nsources-1 do
                for j:=1 to 4 do source[i,j]:=source[i+1,j];

                for j:=1 to 4 do source[nsources,j]:=0;
                nsources:=nsources-1;
                application.ProcessMessages;
                //MainForm.PBmap.Refresh;
                //MainForm.PBplot.Refresh;
                End;
                
                {
                удаляются циклично источники.
                если после текщего номера t удаленного источника:
                -сушествует экстремум и дисперсия уменьшается(TryAddSource(l,k)),
                -положение нового источника не слишом далеко от удаленного но не совпадает с положением удаленного
                то удаляется источник t и добавляется новый источник в конец списка, выход из цикла, TryMoveSource = true;
                иначе восстанавливается удаленный (в конец списка) TryMoveSource = false;
                всяко обновляется счетчик дисперсии
                }
    function    Tmontage.TryMoveSource(t:integer):boolean;
                var x,h,xi,hi,d,di,ro:double;
                    i,l,j,k,q:integer;
                Begin
                if nsources<2 then begin TryMoveSource:=false;exit;end;
                x:=source[t,1];
                h:=source[t,2];
                d:=source[t,3];
                Refresh(x,h,-d);
                disp:=WMNK;
                for i:=t to nsources-1 do
                for j:=1 to 4 do source[i,j]:=source[i+1,j];
                for j:=1 to 4 do source[nsources,j]:=0;
                nsources:=nsources-1;

                if (TryAddSource(l,k)) and ( sqr(x-getxgmap(l))+sqr(h-getygmap(k)) < sqr(h/1) )
                    and ( sqr(x-getxgmap(l))+sqr(h-getygmap(k))+sqr(d-getzgmap(l,k))>0.000000001 )
                then
                begin
                xi:=getxgmap(l);
                hi:=getygmap(k);
                di:=getzgmap(l,k);
                nsources:=nsources+1;
                sourcePut(nsources,xi,hi,di);Refresh(xi,hi,di);
                TryMoveSource:=true;
                disp:=WMNK;

                application.ProcessMessages;
                //MainForm.PBmap.Refresh;
                //MainForm.PBplot.Refresh;
                end
                else
                begin
                nsources:=nsources+1;
                sourcePut(nsources,x,h,d);Refresh(x,h,d);
                TryMoveSource:=false;
                disp:=WMNK;
                exit;
                end;

                if (t<nsources) then q:=t+1 else q:=1;
                TryMoveSource(q);

                End;


   procedure    Tmontage.SearchAll(var pr:TprogressBar; var slabel1,slabel2,slabel3,slabel4:Tlabel);
                var k,i,j,l,c,t:longint;
                    b:boolean;
                    xo,ho,dens:double;
                    xi,hi:double;
                    ch:char;
                    f,g,q:textfile;
                    Wfinal,mnkfinal,mnk0:double;
                Begin
                ncopysources:=0;
                disp:=WMNK;
                mnk0:=mnk5;
                wfinal:=disp+1e-10;
                maxlevel:=+disp*nsensor/3;
                minlevel:=-disp*nsensor/3;

                slabel1.visible:=true;
                slabel1.Caption:='seeking of sources...';
                pr.min:=1;
                pr.max:=ncycles;

                AssignFile(f,'time_mnk.dat');
                rewrite(f);

                AssignFile(q,'out_sources.dat');
                rewrite(q);

                //создаем начальное рапределение источников числом не более Maxnsources
                while ( (nsources<Maxnsources) and AddSource(i,k) ) do;

                for j:=1 to ncycles do
                begin

                maxlevel:=+disp*nsensor;
                minlevel:=-maxlevel;

                {
                //до тех пор, пока не удастся "перемещение" хоть какого-нибудь источника (TryMoveSource) и
                // число источников больше 1, удаляем источник
                while not TryMoveSource and  (nsources>1) do DelSource;

                //добавляем источники до тех пор, пока выполняются необходимые условия (экстремум и уменьшение дисперсии),
                //а также пока число источников не превышает Maxnsources
                while ( (nsources<Maxnsources) and AddSource(i,k) ) do;
                }
                while not TryMoveSource(1) and (nsources>1) and (not bstop) do DelSource;
                while  (nsources<Maxnsources) and AddSource(i,k) and (not bstop) do;

                application.ProcessMessages;
                //MainForm.PBmap.Refresh;
                //MainForm.PBplot.Refresh;
                MainForm.RefreshMap(nil);
                pr.Position:=j;
                slabel2.caption:='sources: '+inttostr(nsources)+ ' out of '+inttostr(Maxnsources);
                slabel3.caption:='W-residual: '+ FloattostrF(disp/disp0*100,ffFixed,2,2)+'% ('+ FloattostrF(wfinal/disp0*100,ffFixed,2,2)+'%)';
                slabel4.caption:='residual: '+ FloattostrF(mnk5/mnk0*100,ffFixed,2,2)+'% ('+ FloattostrF(mnkfinal/mnk0*100,ffFixed,2,2)+'%)';

                if (wfinal>disp) and (nsources=Maxnsources) then
                begin
                wfinal:=disp;
                mnkfinal:=mnk5;
                PutCopySource;
                end;

                writeln(f,j,' ',wfinal/disp0*100:0:6,' ',mnkfinal/mnk0*100:0:6);


                for i:=1 to ncopysources do
                begin
                write(q,' ',j);
                for k:=1 to 4 do write(q,' ',copysource[i,k]);writeln(q,' ',wfinal/disp0*100);
                end;


                if bstop then break;

                end;{j}
                closefile(f);
                closefile(q);

                if (wfinal<disp) then
                begin
                disp:=wfinal;
                RefreshCopySources;
                GetCopySource;
                end;
                slabel2.caption:='sources: '+inttostr(nsources)+ ' out of '+inttostr(Maxnsources);
                slabel3.caption:='W-residual: '+ FloattostrF(disp/disp0*100,ffFixed,2,2)+'%';
                slabel4.caption:='residual: '+ FloattostrF(mnkfinal/mnk0*100,ffFixed,2,2)+'%';
                pr.Position:=pr.min;
                slabel1.visible:=false;

                if fileexists('mnk.dat') then
                begin
                AssignFile(g,'mnk.dat');
                append(g);
                end
                else
                begin
                AssignFile(g,'mnk.dat');
                rewrite(g);
                end;
                writeln(g,UTF8decode(MainForm.FileNameOpenEditor.FileName),' ',disp/disp0*100:0:6,' ',mnkfinal/mnk0*100:0:6,' ',nsources);
                closefile(g);

                //MainForm.PBmap.Refresh;
                //MainForm.PBplot.Refresh;
                MainForm.RefreshMap(Nil);
                End;
                

    function    Tmontage.Lor(x,y:double):double;
                var s,hk,xk,yk,zk:double;
                    sigx,sigy:double;
                    k:integer;
                Begin
                s:=0;
                for k:=1 to nsources do
                begin
                hk:=source[k,2]*smWidth;
                xk:=source[k,1];
                yk:=source[k,2];
                zk:=source[k,4];
                sigx:=hk/smAspect;
                sigy:=hk*smAspect;
                if (hk=0) then continue else
                //s:=s+zk*sqr(hk)/sqr(sqr(hk)+sqr(x-xk)/smAspect+sqr(y-yk)*smAspect)/pi;
                s:=s+zk/sigx/sigy*exp(-sqr((x-xk)/sigx)/2-sqr((y-yk)/sigy)/2);
                end;
                Lor:=s/2/pi;
                End;

    procedure   Tmontage.TabsmMap;
                var i,k:integer;
                    c,x,dx,y,dy:double;
                    f:textfile;
                Begin

                smmin:=+1e10;
                smmax:=-1e10;

                dx:=(ox2-ox1)/(smmx-1);
                dy:=(oy2-oy1)/(smmy-1);

                assignfile(f,'out.dat');
                rewrite(f);

                y:=oy1;
                for k:=1 to smMy do
                begin
                x:=ox1;
                for i:=1 to smMx do
                begin
                c:=Lor(x,y);
                if smmin>c then smmin:=c;
                if smmax<c then smmax:=c;
                smMap[i,k]:=c;
                writeln(f,x,' ',y,' ',c);
                x:=x+dx;
                end;
                y:=y+dy;
                end;
                if (smmin=smmax) then smmax:=smmin+1;
                writeln(f,smmax,' ',smmin);
                closefile(f);
                End;


end.

