unit TabGrid;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Buttons,
  StdCtrls, Spin, Main, ExtCtrls;

type

  { TFormGrid }

  TFormGrid = class(TForm)
    ButtonCancel: TButton;
    ButtonOK: TButton;
    CheckBoxLast: TCheckBox;
    FloatSpinEditnsensor: TFloatSpinEdit;
    FloatSpinEditxmax: TFloatSpinEdit;
    FloatSpinEditxmin: TFloatSpinEdit;
    FloatSpinEditymax: TFloatSpinEdit;
    FloatSpinEditymin: TFloatSpinEdit;
    Label1: TLabel;
    LabelMaxnsources: TLabel;
    Labelnsensor: TLabel;
    Labelncycles: TLabel;
    LabelDx: TLabel;
    LabelDy: TLabel;
    Labelgmx: TLabel;
    Labelgmy: TLabel;
    Labelxmax: TLabel;
    Labelxmin: TLabel;
    Labelymax: TLabel;
    Labelymin: TLabel;
    RadioGroupPlus: TRadioGroup;
    SpinEditMaxnsources: TSpinEdit;
    SpinEditncycles: TSpinEdit;
    SpinEditGmx: TSpinEdit;
    SpinEditGmy: TSpinEdit;
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);
    procedure CheckBoxLastChange(Sender: TObject);
    procedure FloatSpinEditnsensorChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FloatSpinEditxmaxChange(Sender: TObject);
    procedure FloatSpinEditxminChange(Sender: TObject);
    procedure FloatSpinEditymaxChange(Sender: TObject);
    procedure FloatSpinEdityminChange(Sender: TObject);
    procedure RadioGroupPlusClick(Sender: TObject);
    procedure SpinEditGmxChange(Sender: TObject);
    procedure SpinEditGmyChange(Sender: TObject);
    procedure SpinEditMaxnsourcesChange(Sender: TObject);
    procedure SpinEditncyclesChange(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  FormGrid: TFormGrid;

implementation uses montage;

{ TFormGrid }

procedure TFormGrid.FormCreate(Sender: TObject);
          begin
          with check do
          begin
          SpinEditGmx.Value:=gmx;
          SpinEditGmy.Value:=gmy;
          FloatSpinEditxmin.Value:=wx1;
          FloatSpinEditxmax.Value:=wx2;
          FloatSpinEditymin.Value:=wy1;
          FloatSpinEditymax.Value:=wy2;
          SpinEditMaxnsources.Value:=Maxnsources;
          FloatSpinEditnSensor.Value:=nsensor;
          SpinEditncycles.Value:=ncycles;
          checkplus:=true;
          checkminus:=false;
          checkboxlast.Enabled:=bsource;
          if gmx>1 then
          labeldx.Caption:='dx = '+floattostrF((wx2-wx1)/(gmx-1),ffFixed,5,5);
          if gmy>1 then
          labeldy.Caption:='dy = '+floattostrF((wy2-wy1)/(gmy-1),ffFixed,5,5);
          end;
          end;


procedure TFormGrid.RadioGroupPlusClick(Sender: TObject);
          begin
          with check do
          case RadioGroupPlus.ItemIndex of
          0: begin checkplus:=true;checkminus:=false;end;
          1: begin checkplus:=false;checkminus:=true;end;
          2: begin checkplus:=true;checkminus:=true;end;
          end;
          end;



procedure TFormGrid.ButtonOKClick(Sender: TObject);
          var i:longint;
              b1,b2:boolean;
          begin
          if not bkarkas then exit;
          ButtonOK.Enabled:=false;
          with check,MainForm do
          begin
          bstop:=false;
          TabGMap(progresswave,LabelInfo);
          if bstop then begin bstop:=false;exit;end;
          disp0:=WMNK;

          if checkboxlast.Checked
          then
          for i:=1 to nsources do check.Refresh(source[i,1],source[i,2],source[i,3])
          else
          nsources:=0;

          bgrid:=true;

          end;{with check,MainForm}


          //ButtonOK.Enabled:=true;
          end;

procedure TFormGrid.CheckBoxLastChange(Sender: TObject);
begin

end;



procedure TFormGrid.ButtonCancelClick(Sender: TObject);
          begin
          check.bstop:=true;
          end;


procedure TFormGrid.FloatSpinEditnsensorChange(Sender: TObject);
          begin
          with check do
          begin
          nsensor:=FloatSpinEditnsensor.Value;
          maxlevel:=+disp*nsensor;
          minlevel:=-disp*nsensor;
          end;
          end;


procedure TFormGrid.FloatSpinEditxmaxChange(Sender: TObject);
          begin
          with check do
          begin
          wx2:=FloatSpinEditxmax.Value;
          if gmx>1 then
          labeldx.Caption:='dx = '+floattostrF((wx2-wx1)/(gmx-1),ffFixed,5,5);
          end;
          end;
          

procedure TFormGrid.FloatSpinEditxminChange(Sender: TObject);
          begin
          with check do
          begin
          wx1:=FloatSpinEditxmin.Value;
          if gmx>1 then
          labeldx.Caption:='dx = '+floattostrF((wx2-wx1)/(gmx-1),ffFixed,5,5);
          end;
          end;
          

procedure TFormGrid.FloatSpinEditymaxChange(Sender: TObject);
          begin
          with check do
          begin
          wy2:=FloatSpinEditymax.Value;
          if gmy>1 then
          labeldy.Caption:='dy = '+floattostrF((wy2-wy1)/(gmy-1),ffFixed,5,5);
          end;
          end;

procedure TFormGrid.FloatSpinEdityminChange(Sender: TObject);
          begin
          with check do
          begin
          wy1:=FloatSpinEditymin.Value;
          if gmy>1 then
          labeldy.Caption:='dy = '+floattostrF((wy2-wy1)/(gmy-1),ffFixed,5,5);
          end;
          end;


procedure TFormGrid.SpinEditGmxChange(Sender: TObject);
          begin
          with check do
          begin
          gmx:=SpinEditGmx.value;
          if gmx>1 then
          labeldx.Caption:='dx = '+floattostrF((wx2-wx1)/(gmx-1),ffFixed,5,5);
          end;
          end;

procedure TFormGrid.SpinEditGmyChange(Sender: TObject);
          begin
          with check do
          begin
          gmy:=SpinEditGmy.value;
          if gmy>1 then
          labeldy.Caption:='dy = '+floattostrF((wy2-wy1)/(gmy-1),ffFixed,5,5);
          end;
          end;

procedure TFormGrid.SpinEditMaxnsourcesChange(Sender: TObject);
          begin
          check.Maxnsources:=SpinEditMaxnsources.Value;
          end;

procedure TFormGrid.SpinEditncyclesChange(Sender: TObject);
          begin
          check.ncycles:=SpinEditncycles.Value;
          end;




initialization
  {$I tabgrid.lrs}

end.

